cookutils annotate cook @ rev 1019

cook: add fix() to use '--as-needed' linker flag in compile_rules(); cookit(): make QA fail on empty vars / bad values; remove_already_packed(): fix bug when $PACKAGE not listed in $SPLIT and we use this function for the default set. lighttpd/index.cgi: sort orphans. modules/precheck: separate error message by empty lines.
author Aleksej Bobylev <al.bobylev@gmail.com>
date Thu Dec 07 14:31:28 2017 +0200 (2017-12-07)
parents 6907a43402f6
children dc7238a11470
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
paul@647 4 # before adding or modifying any code in cook!
pankso@1 5 #
al@899 6 # Copyright (C) SliTaz GNU/Linux - GNU GPL v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
al@728 9
pankso@422 10 . /usr/lib/slitaz/libcook.sh
pankso@1 11
pankso@633 12 VERSION="3.2"
al@779 13 export output=raw
al@596 14
al@728 15
al@596 16 # Internationalization.
al@596 17
al@728 18 export TEXTDOMAIN='cook'
al@596 19
al@596 20
pankso@1 21 #
pankso@1 22 # Functions
pankso@1 23 #
pankso@1 24
pankso@1 25 usage() {
al@728 26 cat <<EOT
pankso@1 27
al@728 28 $(boldify "$(_ 'Usage:')") $(_ 'cook [package|command] [list|--option]')
pankso@1 29
al@728 30 $(boldify "$(_ 'Commands:')")
al@728 31 usage|help $(_ 'Display this short usage.')
al@728 32 setup $(_ 'Setup your build environment.')
al@728 33 *-setup $(_ 'Setup a cross environment.')
al@728 34 * = {arm|armv6hf|armv7|x86_64}
al@728 35 test $(_ 'Test environment and cook a package.')
al@728 36 list-wok $(_ 'List packages in the wok.')
al@728 37 search $(_ 'Simple packages search function.')
al@728 38 new $(_ 'Create a new package with a receipt.')
al@728 39 list $(_ 'Cook a list of packages.')
al@728 40 clean-wok $(_ 'Clean-up all packages files.')
al@728 41 clean-src $(_ 'Clean-up all packages sources.')
al@728 42 uncook $(_ 'Check for uncooked packages')
al@728 43 pkgdb $(_ 'Create packages DB lists and flavors.')
pankso@1 44
al@728 45 $(boldify "$(_ 'Options:')")
al@728 46 cook <pkg>
al@728 47 --clean -c $(_ 'clean the package in the wok.')
al@728 48 --install -i $(_ 'cook and install the package.')
al@728 49 --getsrc -gs $(_ 'get the package source tarball.')
al@728 50 --block -b $(_ 'block a package so cook will skip it.')
al@728 51 --unblock -ub $(_ 'unblock a blocked package.')
al@728 52 --cdeps $(_ 'check dependencies of cooked package.')
al@728 53 --pack $(_ 'repack an already built package.')
al@728 54 --debug $(_ 'display debugging messages.')
al@728 55 --continue $(_ 'continue running compile_rules.')
al@728 56 cook new <pkg>
al@728 57 --interactive -x $(_ 'create a receipt interactively.')
al@728 58 cook setup
al@728 59 --wok $(_ 'clone the cooking wok from Hg repo.')
al@728 60 --stable $(_ 'clone the stable wok from Hg repo.')
al@728 61 --undigest $(_ 'clone the undigest wok from Hg repo.')
al@728 62 --tiny $(_ 'clone the tiny SliTaz wok from Hg repo.')
al@728 63 --forced $(_ 'force reinstall of chroot packages.')
al@728 64 cook pkgdb
al@728 65 --flavors $(_ 'create up-to-date flavors files.')
al@932 66 cook splitdb $(_ 'create up-to-date split.db file.')
pankso@1 67
pankso@1 68 EOT
pankso@1 69 exit 0
pankso@1 70 }
pankso@1 71
al@728 72
paul@62 73 # We don't want these escapes in web interface.
al@728 74
pankso@1 75 clean_log() {
al@931 76 sed -i -e 's|\[70G\[ \[1;32m| |' \
al@931 77 -e 's|\[0;39m \]||' $LOGS/${1:-$pkg}.log
pankso@1 78 }
pankso@1 79
al@728 80
paul@62 81 # Be sure package exists in wok.
al@728 82
pankso@1 83 check_pkg_in_wok() {
al@890 84 [ -d "$WOK/$pkg" ] || die 'Unable to find package "%s" in the wok' "$pkg"
pankso@1 85 }
pankso@1 86
al@728 87
paul@62 88 # Initialize files used in $CACHE
al@728 89
pankso@52 90 init_db_files() {
al@728 91 _ 'Creating directories structure in "%s"' "$SLITAZ"
xfred222@559 92 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS $FEEDS
al@728 93 _ 'Creating DB files in "%s"' "$CACHE"
al@933 94 touch $activity $command $broken $blocked $CACHE/webstat
al@933 95 chown www:www $cache/webstat
pankso@52 96 }
pankso@52 97
al@728 98
paul@62 99 # Paths used in receipt and by cook itself.
al@728 100
pankso@1 101 set_paths() {
al@1003 102 # Kernel version is set from wok/linux or installed/linux-api-headers(wok-undigest)
al@1003 103 if [ -f "$WOK/linux/receipt" ]; then
al@1003 104 kvers=$(. $WOK/linux/receipt; echo $VERSION)
al@1003 105 kbasevers=$(echo $kvers | cut -d. -f1,2)
al@1003 106 elif [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
al@1003 107 kvers=$(. $INSTALLED/linux-api-headers/receipt; echo $VERSION)
al@1003 108 kbasevers=$(echo $kvers | cut -d. -f1,2)
al@1003 109 fi
al@1003 110
al@1003 111 # Python version
al@1003 112 [ -f "$WOK/python/receipt" ] && pyvers=$(. $WOK/python/receipt; echo $VERSION)
al@1003 113 # Perl version for some packages needed it
al@1003 114 [ -f "$WOK/perl/receipt" ] && perlvers=$(. $WOK/perl/receipt; echo $VERSION)
al@1003 115
al@904 116 pkgdir="$WOK/$pkg"
al@841 117 . "$pkgdir/receipt"
al@728 118 basesrc="$pkgdir/source"
al@728 119 tmpsrc="$basesrc/tmp"
al@728 120 src="$basesrc/$PACKAGE-$VERSION"
al@728 121 taz="$pkgdir/taz"
al@904 122 pack="$taz/${1:-$PACKAGE}-$VERSION$EXTRAVERSION" # v2: multiple taz/* folders
al@728 123 fs="$pack/fs"
al@728 124 stuff="$pkgdir/stuff"
al@728 125 install="$pkgdir/install"
al@904 126
slaxemulator@492 127 pkgsrc="${SOURCE:-$PACKAGE}-${KBASEVER:-$VERSION}"
slaxemulator@492 128 lzma_tarball="$pkgsrc.tar.lzma"
al@904 129
al@904 130 [ -n "$PATCH" -a -z "$PTARBALL" ] && PTARBALL="$(basename $PATCH)"
al@904 131
al@728 132 if [ -n "$WANTED" ]; then
al@728 133 basesrc="$WOK/$WANTED/source"
al@728 134 src="$basesrc/$WANTED-$VERSION"
al@728 135 install="$WOK/$WANTED/install"
al@728 136 wanted_stuff="$WOK/$WANTED/stuff"
pankso@1 137 fi
al@904 138
al@904 139 [ -n "$SOURCE" ] && source_stuff="$WOK/$SOURCE/stuff"
al@904 140
pankso@9 141 # Old way compatibility.
al@728 142 _pkg="$install"
pankso@1 143 }
pankso@1 144
al@728 145
pankso@144 146 # Create source tarball when URL is a SCM.
al@728 147
pankso@144 148 create_tarball() {
slaxemulator@498 149 local tarball
al@728 150 tarball="$pkgsrc.tar.bz2"
al@728 151 [ -n "$LZMA_SRC" ] && tarball="$lzma_tarball"
al@728 152 _ 'Creating tarball "%s"' "$tarball"
al@728 153 if [ -n "$LZMA_SRC" ]; then
slaxemulator@498 154 tar -c $pkgsrc | lzma e $SRC/$tarball -si $LZMA_SET_DIR || exit 1
al@728 155 LZMA_SRC=''
pankso@162 156 else
al@728 157 tar -cjf $tarball $pkgsrc || exit 1
al@728 158 mv $tarball $SRC; rm -rf $pkgsrc
pankso@162 159 fi
al@728 160 TARBALL="$tarball"
pankso@144 161 }
pankso@144 162
al@728 163
pankso@145 164 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 165 # tarball here.
al@728 166
pankso@1 167 get_source() {
pascal@610 168 local url
al@890 169 url=${WGET_URL#*|}
ernia@571 170 set_paths
pankso@115 171 pwd=$(pwd)
pankso@9 172 case "$WGET_URL" in
al@890 173 http://*|ftp://*|https://*)
al@890 174 url="$MIRROR_URL/sources/packages/${TARBALL:0:1}/$TARBALL"
al@890 175 wget -T 60 -c -O $SRC/$TARBALL $WGET_URL ||
al@890 176 wget -T 60 -c -O $SRC/$TARBALL $url ||
al@890 177 die 'ERROR: %s' "wget $WGET_URL"
al@890 178 ;;
al@728 179
pankso@9 180 hg*|mercurial*)
al@728 181 _ 'Getting source from %s...' 'Hg'
al@728 182 _ 'URL: %s' "$url"
al@728 183 _ 'Cloning to "%s"' "$pwd/$pkgsrc"
al@728 184 if [ -n "$BRANCH" ]; then
al@728 185 _ 'Hg branch: %s' "$BRANCH"
al@890 186 hg clone $url --rev $BRANCH $pkgsrc ||
al@890 187 die 'ERROR: %s' "hg clone $url --rev $BRANCH"
pankso@246 188 else
al@890 189 hg clone $url $pkgsrc || die 'ERROR: %s' "hg clone $url"
pankso@246 190 fi
pankso@255 191 rm -rf $pkgsrc/.hg
al@890 192 create_tarball
al@890 193 ;;
al@728 194
pankso@9 195 git*)
al@728 196 _ 'Getting source from %s...' 'Git'
al@728 197 _ 'URL: %s' "$url"
al@688 198 cd $SRC
al@890 199 git clone $url $pkgsrc || die 'ERROR: %s' "git clone $url"
al@728 200 if [ -n "$BRANCH" ]; then
al@728 201 _ 'Git branch: %s' "$BRANCH"
al@728 202 cd $pkgsrc; git checkout $BRANCH; cd ..
pankso@63 203 fi
al@688 204 cd $SRC
al@890 205 create_tarball
al@890 206 ;;
al@728 207
pankso@144 208 cvs*)
pankso@144 209 mod=$PACKAGE
al@728 210 [ -n "$CVS_MODULE" ] && mod=$CVS_MODULE
al@728 211 _ 'Getting source from %s...' 'CVS'
al@728 212 _ 'URL: %s' "$url"
al@728 213 [ -n "$CVS_MODULE" ] && _ 'CVS module: %s' "$mod"
al@728 214 _ 'Cloning to "%s"' "$pwd/$mod"
pankso@144 215 cvs -d:$url co $mod && mv $mod $pkgsrc
al@890 216 create_tarball
al@890 217 ;;
al@728 218
pankso@69 219 svn*|subversion*)
al@728 220 _ 'Getting source from %s...' 'SVN'
al@728 221 _ 'URL: %s' "$url"
al@728 222 if [ -n "$BRANCH" ]; then
pankso@161 223 echo t | svn co $url -r $BRANCH $pkgsrc
pankso@161 224 else
pankso@161 225 echo t | svn co $url $pkgsrc
pankso@161 226 fi
al@890 227 create_tarball
al@890 228 ;;
al@728 229
al@590 230 bzr*)
al@728 231 _ 'Getting source from %s...' 'bazaar'
al@590 232 cd $SRC
al@590 233 pkgsrc=${url#*:}
al@728 234 if [ -n "$BRANCH" ]; then
al@590 235 echo "bzr -Ossl.cert_reqs=none branch $url -r $BRANCH"
al@590 236 bzr -Ossl.cert_reqs=none branch $url -r $BRANCH
al@590 237 else
al@590 238 echo "bzr -Ossl.cert_reqs=none branch $url"
al@590 239 bzr -Ossl.cert_reqs=none branch $url
al@728 240 cd $pkgsrc; BRANCH=$(bzr revno); cd ..
al@596 241 _ "Don't forget to add to receipt:"
al@728 242 echo -e "BRANCH=\"$BRANCH\"\n"
al@590 243 fi
al@590 244 mv $pkgsrc $pkgsrc-$BRANCH
al@728 245 pkgsrc="$pkgsrc-$BRANCH"
al@899 246 create_tarball
al@899 247 ;;
al@728 248
pankso@9 249 *)
al@899 250 broken; die 'ERROR: Unable to handle "%s"' "$WGET_URL"
al@899 251 ;;
pankso@9 252 esac
pankso@1 253 }
pankso@1 254
al@728 255
pankso@9 256 # Extract source package.
al@728 257
pankso@1 258 extract_source() {
pankso@177 259 if [ ! -s "$SRC/$TARBALL" ]; then
pankso@177 260 local url
slaxemulator@458 261 url="$MIRROR_URL/sources/packages"
al@728 262 url="$url/${TARBALL:0:1}/$TARBALL"
al@728 263 _ 'Getting source from %s...' 'mirror'
al@728 264 _ 'URL: %s' "$url"
al@728 265 busybox wget -c -P $SRC $url || _ 'ERROR: %s' "wget $url"
pankso@177 266 fi
al@728 267 _ 'Extracting source archive "%s"' "$TARBALL"
pankso@1 268 case "$TARBALL" in
al@728 269 *.tar.gz|*.tgz) tar -xzf $SRC/$TARBALL 2>/dev/null ;;
al@728 270 *.tar.bz2|*.tbz|*.tbz2) tar -xjf $SRC/$TARBALL 2>/dev/null ;;
al@728 271 *.tar.lzma) tar -xaf $SRC/$TARBALL ;;
al@728 272 *.tar.lz|*.tlz) lzip -d < $SRC/$TARBALL | tar -xf - 2>/dev/null ;;
al@728 273 *.tar) tar -xf $SRC/$TARBALL ;;
al@912 274 *.zip|*.xpi) unzip -o $SRC/$TARBALL 2>/dev/null >&2;;
al@728 275 *.xz) unxz -c $SRC/$TARBALL | tar -xf - || \
al@728 276 tar -xf $SRC/$TARBALL 2>/dev/null;;
psychomaniak@827 277 *.7z) 7zr x $SRC/$TARBALL 2>/dev/null >&2 ;;
al@728 278 *.Z|*.z) uncompress -c $SRC/$TARBALL | tar -xf - ;;
al@728 279 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
al@728 280 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
al@728 281 *) cp $SRC/$TARBALL $(pwd) ;;
pankso@1 282 esac
pankso@1 283 }
pankso@1 284
al@728 285
al@834 286 # Display time.
al@834 287
al@834 288 disp_time() {
al@834 289 local sec div min
al@834 290 sec="$1"
al@834 291 div=$(( ($1 + 30) / 60))
al@834 292 case $div in
al@834 293 0) min='';;
al@834 294 # L10n: 'm' is for minutes (approximate cooking time)
al@834 295 *) min=$(_n ' ~ %dm' "$div");;
al@834 296 esac
al@834 297
al@834 298 # L10n: 's' is for seconds (cooking time)
al@834 299 _ '%ds%s' "$sec" "$min"
al@834 300 }
al@834 301
al@834 302
pankso@9 303 # Display cooked package summary.
al@728 304
pankso@1 305 summary() {
al@841 306 set_paths
pankso@1 307 cd $WOK/$pkg
slaxemulator@499 308 [ -d $WOK/$pkg/install ] && prod=$(du -sh $WOK/$pkg/install | awk '{print $1}' 2>/dev/null)
slaxemulator@499 309 [ -d $WOK/$pkg/source ] && srcdir=$(du -sh $WOK/$pkg/source | awk '{print $1}' 2>/dev/null)
al@728 310 [ -n "$TARBALL" ] && srcsize=$(du -sh $SRC/$TARBALL | awk '{print $1}')
al@728 311
al@1003 312 _ 'Summary for: %s' "$PACKAGE $VERSION$EXTRAVERSION"
pankso@1 313 separator
al@728 314
al@596 315 # L10n: keep the same width of translations to get a consistent view
al@728 316 [ -n "$TARBALL" ] && _ 'Src file : %s' "$TARBALL"
al@728 317 [ -n "$srcsize" ] && _ 'Src size : %s' "$srcsize"
al@904 318 [ -n "$srcdir" ] && _ 'Source dir : %s' "$srcdir"
al@728 319 [ -n "$prod" ] && _ 'Produced : %s' "$prod"
al@834 320 _ 'Cook time : %s' "$(disp_time "$time")"
al@728 321 _ 'Cook date : %s' "$(date "$(_ '+%%F %%R')")"
al@728 322 _ 'Host arch : %s' "$ARCH"
al@904 323
al@904 324 separator -
al@912 325 _ ' # : Packed : Compressed : Files : Package name'
al@904 326 separator -
al@904 327 pkgi=1
al@916 328 for i in $(all_names); do
al@1003 329 fs=$(du -sh $WOK/$pkg/taz/$i-$VERSION$EXTRAVERSION | awk '{print $1}')
al@1003 330 pkgname="$i-$VERSION$EXTRAVERSION.tazpkg"
al@904 331 size=$(ls -lh $PKGS/$pkgname | awk '{print $5}')
al@1003 332 files=$(wc -l < $WOK/$pkg/taz/$i-$VERSION$EXTRAVERSION/files.list)
al@912 333 printf "%2d : %7s : %10s : %5s : %s\n" "$pkgi" "$fs" "$size" "$files" "$pkgname"
al@904 334 pkgi=$((pkgi + 1))
al@904 335 done
al@596 336 separator
pankso@1 337 }
pankso@1 338
al@728 339
paul@62 340 # Display debugging error info.
al@728 341
pankso@15 342 debug_info() {
al@779 343 title 'Debug information'
al@596 344 # L10n: specify your format of date and time (to help: man date)
al@596 345 # L10n: not bad one is '+%x %R'
al@728 346 _ 'Cook date: %s' "$(date "$(_ '+%%F %%R')")"
al@890 347 if [ -n "$time" ]; then
al@890 348 times="$(($(date +%s) - $time))"
al@904 349 _ 'Wasted time : %s' "$(disp_time "$times")"
al@890 350 fi
pankso@76 351 for error in \
al@890 352 ERROR 'No package' "cp: can't" "can't open" "can't cd" \
al@728 353 'error:' 'fatal error:' 'undefined reference to' \
al@728 354 'Unable to connect to' 'link: cannot find the library' \
pascal@797 355 'CMake Error' ': No such file or directory' \
paul@798 356 'Could not read symbols: File in wrong format'
pankso@34 357 do
al@890 358 # format "line number:line content"
al@890 359 fgrep -n "$error" $LOGS/$pkg.log
pascal@625 360 done > $LOGS/$pkg.log.debug_info 2>&1
al@890 361 # sort by line number, remove duplicates
al@890 362 sort -gk1,1 -t: -u $LOGS/$pkg.log.debug_info
pascal@625 363 rm -f $LOGS/$pkg.log.debug_info
al@779 364 footer
pankso@15 365 }
pankso@15 366
al@728 367
al@887 368 # A bit smarter function than the classic `cp` command
al@887 369
al@899 370 scopy() {
al@899 371 if [ "$(stat -c %h -- "$1")" -eq 1 ]; then
al@899 372 cp -a "$1" "$2" # copy generic files
al@894 373 else
al@887 374 cp -al "$1" "$2" # copy hardlinks
al@887 375 fi
al@887 376 }
al@887 377
al@887 378
al@912 379 # Copy all generic files (locale, pixmaps, .desktop) from $install to $fs.
al@912 380 # We use standard paths, so some packages need to copy these files with the
al@912 381 # receipt and genpkg_rules.
al@912 382 # This function executes inside the packaging process, before compressor call.
al@728 383
al@728 384 copy_generic_files() {
al@912 385 # Proceed only for "main" package (for v2), and for any packages (v1)
al@912 386 [ "$pkg" == "$PACKAGE" ] || return 0
al@912 387
pankso@1 388 # $LOCALE is set in cook.conf
al@728 389 if [ -n "$LOCALE" -a -z "$WANTED" ]; then
pankso@260 390 if [ -d "$install/usr/share/locale" ]; then
al@912 391 mkdir -p "$fs/usr/share/locale"
al@728 392 for i in $LOCALE; do
al@899 393 if [ -d "$install/usr/share/locale/$i" ]; then
al@973 394 cp -r $install/usr/share/locale/$i $fs/usr/share/locale
pankso@1 395 fi
pankso@1 396 done
pankso@1 397 fi
pankso@1 398 fi
pankso@1 399
al@834 400 # Generic pixmaps copy can be disabled with COOKOPTS="!pixmaps" (or GENERIC_PIXMAPS="no")
al@834 401 if [ "${COOKOPTS/!pixmaps/}" == "$COOKOPTS" -a "$GENERIC_PIXMAPS" != 'no' ]; then
pankso@260 402 if [ -d "$install/usr/share/pixmaps" ]; then
al@912 403 mkdir -p "$fs/usr/share/pixmaps"
al@890 404 for i in png xpm; do
al@913 405 [ -f "$install/usr/share/pixmaps/$PACKAGE.$i" -a ! -f "$fs/usr/share/pixmaps/$PACKAGE.$i" ] &&
al@973 406 cp -r $install/usr/share/pixmaps/$PACKAGE.$i $fs/usr/share/pixmaps
al@890 407 done
pankso@1 408 fi
pankso@1 409 fi
pankso@1 410
pankso@1 411 # Desktop entry (.desktop).
al@834 412 # Generic desktop entry copy can be disabled with COOKOPTS="!menus" (or GENERIC_MENUS="no")
al@834 413 if [ "${COOKOPTS/!menus/}" == "$COOKOPTS" -a "$GENERIC_MENUS" != 'no' ]; then
al@912 414 if [ -d "$install/usr/share/applications" -a -z "$WANTED" ]; then
al@912 415 mkdir -p "$fs/usr/share"
al@973 416 cp -r $install/usr/share/applications $fs/usr/share
erjo@284 417 fi
pankso@1 418 fi
al@912 419 }
al@912 420
al@912 421
al@912 422 # Copy pixmaps, desktop files and licenses from $stuff to $install.
al@912 423 # This function executes after the main compile_rules() is done.
al@912 424
al@912 425 copy_generic_stuff() {
al@912 426 # Custom or homemade PNG pixmap can be in stuff.
al@912 427 if [ -f "$stuff/$PACKAGE.png" ]; then
al@912 428 mkdir -p $install/usr/share/pixmaps
al@912 429 cp $stuff/$PACKAGE.png $install/usr/share/pixmaps
al@912 430 fi
pankso@1 431
pankso@1 432 # Homemade desktop file(s) can be in stuff.
pankso@1 433 if [ -d "$stuff/applications" ]; then
al@912 434 mkdir -p $install/usr/share
al@973 435 cp -r $stuff/applications $install/usr/share
pankso@1 436 fi
pankso@1 437 if [ -f "$stuff/$PACKAGE.desktop" ]; then
al@912 438 mkdir -p $install/usr/share/applications
al@912 439 cp $stuff/$PACKAGE.desktop $install/usr/share/applications
pankso@1 440 fi
pankso@662 441
slaxemulator@500 442 # Add custom licenses
slaxemulator@500 443 if [ -d "$stuff/licenses" ]; then
al@912 444 mkdir -p $install/usr/share/licenses
al@973 445 cp -r $stuff/licenses $install/usr/share/licenses/$PACKAGE
slaxemulator@500 446 fi
pankso@1 447 }
pankso@1 448
al@728 449
al@769 450 # Update installed.cook.diff
al@769 451
al@769 452 update_installed_cook_diff() {
al@769 453 # If a cook failed deps are removed.
al@769 454 cd $root$INSTALLED; ls -1 > $CACHE/installed.cook
al@769 455 cd $CACHE
al@769 456 [ "$1" == 'force' -o ! -s '/tmp/installed.cook.diff' ] && \
al@769 457 busybox diff installed.list installed.cook > /tmp/installed.cook.diff
al@931 458 deps=$(grep ^+[a-zA-Z0-9] /tmp/installed.cook.diff | wc -l)
al@769 459 }
al@769 460
al@769 461
pankso@8 462 # Remove installed deps.
al@728 463
pankso@8 464 remove_deps() {
pankso@8 465 # Now remove installed build deps.
al@728 466 diff='/tmp/installed.cook.diff'
al@899 467 [ -s "$diff" ] || return
al@899 468
al@931 469 deps=$(grep ^+[a-zA-Z0-9] $diff | sed 's|^+||')
al@931 470 nb=$(grep ^+[a-zA-Z0-9] $diff | wc -l)
al@899 471 newline
al@899 472 _n 'Build dependencies to remove:'; echo " $nb"
al@899 473 [ -n "$root" ] && echo "root=\"$root\""
al@899 474 {
al@728 475 _n 'Removing:'
al@728 476 for dep in $deps; do
pankso@8 477 echo -n " $dep"
al@982 478 # Do not waste time uninstalling the packages if we are inside
al@982 479 # aufs chroot - unmounting chroot will "uninstall" all packages.
al@982 480 [ -s /aufs-umount.sh ] ||
pankso@426 481 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
pankso@8 482 done
al@949 483 } | busybox fold -sw80
al@982 484 newline; newline
al@982 485 # Keep the last diff for debug and info.
al@982 486 mv -f $diff $CACHE/installed.diff
al@899 487 }
al@899 488
al@899 489
paul@900 490 # Automatically patch the sources.
al@899 491
al@899 492 patchit() {
al@899 493 [ -f "$stuff/patches/series" ] || return
al@899 494
al@938 495 IFS=$'\n'
al@899 496 while read i; do
al@940 497 patchname=$(echo ${i%%#*} | cut -d' ' -f1) # allow comments (anything after the # or space)
al@984 498 case $patchname in # allow patch options in form <options_no_spaces>|<file_name>
al@984 499 *\|*) patchopts="${patchname%|*}"; patchname="${patchname#*|}";;
al@984 500 *) patchopts='-Np1';;
al@984 501 esac
al@938 502 [ -n "$patchname" ] || continue # allow empty lines
al@938 503 [ -f "$src/done.$patchname" ] && continue # already applied (useful with `cook --continue`)
al@912 504 newline
al@938 505 _ 'Applying patch %s' "$patchname"
al@984 506 patch $patchopts -i $stuff/patches/$patchname | sed 's|^| |'
al@938 507 touch $src/done.$patchname
al@899 508 done < $stuff/patches/series
al@912 509 newline
al@938 510 unset IFS
pankso@1 511 }
pankso@1 512
al@834 513
al@907 514 # Check source tarball integrity.
al@907 515
al@907 516 check_integrity() {
al@909 517 for i in sha1 sha3 sha256 sha512 md5; do
al@909 518 I=$(echo $i | tr 'a-z' 'A-Z')
al@909 519 eval sum=\$TARBALL_$I
al@909 520 if [ -n "$sum" ]; then
al@909 521 newline
al@909 522 _ 'Checking %ssum of source tarball...' "$i"
al@909 523 echo "$sum $SRC/$TARBALL" | ${i}sum -c || exit 1
al@909 524 fi
al@909 525 done
al@909 526 newline
al@907 527 }
al@907 528
al@907 529
al@1019 530 # Misc fix functions
al@1019 531
al@1019 532 fix() {
al@1019 533 case $1 in
al@1019 534 # https://bugzilla.gnome.org/show_bug.cgi?id=655517
al@1019 535 # https://wiki.gentoo.org/wiki/Project:Quality_Assurance/As-needed
al@1019 536 ld)
al@1019 537 export LDFLAGS="$LDFLAGS -Wl,-Os,--as-needed"
al@1019 538 ;;
al@1019 539 libtool)
al@1019 540 if [ -e 'libtool' ]; then
al@1019 541 sed -i 's| -shared | -Wl,-Os,--as-needed\0|g' libtool
al@1019 542 else
al@1019 543 echo "fix libtool: warning: libtool absent, nothing to fix."
al@1019 544 fi
al@1019 545 ;;
al@1019 546 esac
al@1019 547 }
al@1019 548
al@1019 549
pankso@1 550 # The main cook function.
al@728 551
pankso@1 552 cookit() {
al@899 553 if [ -n "$SETUP_MD5" -a "$SETUP_MD5" != "$(ls $root$INSTALLED | md5sum | cut -c1-32)" ]; then
pascal@883 554 _ 'ERROR: Broken setup. Abort.'
pascal@883 555 return
pascal@882 556 fi
pascal@882 557
al@779 558 title 'Cook: %s' "$PACKAGE $VERSION"
pankso@1 559 set_paths
pankso@359 560
pankso@377 561 # Handle cross-tools.
pankso@359 562 case "$ARCH" in
pankso@675 563 arm*|x86_64)
paul@387 564 # CROSS_COMPILE is used by at least Busybox and the kernel to set
al@596 565 # the cross-tools prefix. Sysroot is the root of our target arch
al@728 566 sysroot="$CROSS_TREE/sysroot"
al@728 567 tools="$CROSS_TREE/tools"
pankso@443 568 # Set root path when cross compiling. ARM tested but not x86_64
pankso@443 569 # When cross compiling we must install build deps in $sysroot.
al@737 570 arch="-$ARCH"
al@728 571 root="$sysroot"
al@728 572 _ '%s sysroot: %s' "$ARCH" "$sysroot"
al@728 573 _ 'Adding "%s" to PATH' "$tools/bin"
al@728 574 export PATH="$PATH:$tools/bin"
al@728 575 export PKG_CONFIG_PATH="$sysroot/usr/lib/pkgconfig"
al@737 576 export CROSS_COMPILE="$HOST_SYSTEM-"
al@728 577 _ 'Using cross-tools: %s' "$CROSS_COMPILE"
al@728 578 if [ "$ARCH" == 'x86_64' ]; then
al@737 579 export CC="$HOST_SYSTEM-gcc -m64"
al@737 580 export CXX="$HOST_SYSTEM-g++ -m64"
pankso@438 581 else
al@737 582 export CC="$HOST_SYSTEM-gcc"
al@737 583 export CXX="$HOST_SYSTEM-g++"
pankso@438 584 fi
al@737 585 export AR="$HOST_SYSTEM-ar"
al@737 586 export AS="$HOST_SYSTEM-as"
al@737 587 export RANLIB="$HOST_SYSTEM-ranlib"
al@737 588 export LD="$HOST_SYSTEM-ld"
al@737 589 export STRIP="$HOST_SYSTEM-strip"
al@899 590 export LIBTOOL="$HOST_SYSTEM-libtool"
al@899 591 ;;
pankso@359 592 esac
pankso@359 593
al@1019 594 @@PREFIX@@/libexec/cookutils/precheck $receipt || exit 1 # former receipt_quality()
al@904 595
pankso@44 596 cd $pkgdir
al@728 597 [ -z "$continue" ] && rm -rf source 2>/dev/null
al@728 598 rm -rf install taz 2>/dev/null
pankso@1 599
al@860 600 # Disable -pipe if less than 512 MB free RAM.
al@860 601 free=$(awk '/^MemFree|^Buffers|^Cached/{s+=$2}END{print int(s/1024)}' /proc/meminfo)
al@860 602 if [ "$free" -lt 512 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
al@860 603 _ 'Disabling -pipe compile flag: %d MB RAM free' "$free"
al@728 604 CFLAGS="${CFLAGS/-pipe}"; CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
al@728 605 CXXFLAGS="${CXXFLAGS/-pipe}"; CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 606 fi
pankso@1 607 unset free
pankso@1 608
pankso@232 609 # Export flags and path to be used by make and receipt.
al@728 610 DESTDIR="$pkgdir/install"
al@596 611 # FIXME: L10n: Is this the right time for 'LC_ALL=C LANG=C'?
pankso@232 612 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
pankso@358 613 #LDFLAGS
pankso@1 614
al@904 615 # BUILD_DEPENDS may vary depending on the ARCH
al@904 616 case "$ARCH" in
al@904 617 arm*) [ -n "$BUILD_DEPENDS_arm" ] && BUILD_DEPENDS=$BUILD_DEPENDS_arm ;;
al@904 618 x86_64) [ -n "$BUILD_DEPENDS_x86_64" ] && BUILD_DEPENDS=$BUILD_DEPENDS_x86_64 ;;
al@904 619 esac
al@904 620
pankso@126 621 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 622 # (ex: libusb-dev :: libusb).
al@912 623 # rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
al@912 624 # touch $CACHE/installed.local $CACHE/installed.web
al@728 625 [ -n "$BUILD_DEPENDS" ] && _ 'Checking build dependencies...'
al@728 626 [ -n "$root" ] && _ 'Using packages DB: %s' "$root$DB"
al@899 627
al@935 628 # Get the list of installed packages
al@935 629 cd $root$INSTALLED; ls > $CACHE/installed.list
al@935 630
al@912 631 for action in check install; do
al@912 632 for dep in $BUILD_DEPENDS; do
al@912 633 implicit="${dep%-dev}"; [ "$implicit" == "$dep" ] && implicit=''
al@912 634 for i in $dep $implicit; do
al@912 635 # Skip if package already installed
al@912 636 [ -f "$root$INSTALLED/$i/receipt" ] && continue
al@899 637
al@912 638 case $action in
al@912 639 check)
al@912 640 # Search for local package or local provided-package
al@912 641 name=$(awk -F$'\t' -vpkg="$i" '{
al@912 642 if (index(" " $1 " " $10 " ", " " pkg " ")) {print $1; exit}
al@912 643 }' "$PKGS/packages.info")
al@912 644 if [ -z "$name" ]; then
al@912 645 # Search for package in mirror
al@912 646 name="$(awk -F$'\t' -vi="$i" '$1==i{print $1; exit}' "$root$DB/packages.info")"
al@912 647 [ -z "$name" -a "$i" == "$dep" ] && die 'ERROR: unknown dep "%s"' "$i"
al@912 648 fi
al@912 649 ;;
al@912 650 install)
al@912 651 tazpkg get-install $i --root=$root --local --quiet --cookmode || { broken; exit 1; }
al@912 652 ;;
al@912 653 esac
al@912 654 done
pankso@126 655 done
pankso@1 656 done
pankso@225 657
al@912 658 # # Have we a missing build dep to cook?
al@912 659 # if [ -s "$CACHE/missing.dep" ] && [ -n "$AUTO_COOK" ]; then
al@912 660 # _ 'Auto cook config is set: %s' "$AUTO_COOK"
al@912 661 # cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
al@912 662 # for i in $(uniq $CACHE/missing.dep); do
al@912 663 # (_ 'Building dep (wok/pkg) : %s' "$i $vers") | \
al@912 664 # tee -a $LOGS/$PACKAGE.log.$$
al@912 665 # # programmers: next two messages are exact copy from remove_deps()
al@912 666 # togrep1=$(_n 'Build dependencies to remove:')
al@912 667 # togrep2=$(_n 'Removing:')
al@912 668 # cook $i || (_ "ERROR: can't cook dep \"%s\"" "$i" && newline && \
al@912 669 # fgrep $togrep1 $LOGS/$i.log && \
al@912 670 # fgrep $togrep2 $LOGS/$i.log && newline) | \
al@912 671 # tee -a $LOGS/$PACKAGE.log.$$ && break
al@912 672 # done
al@912 673 # rm -f $CACHE/missing.dep
al@912 674 # mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
al@912 675 # fi
al@912 676 #
al@912 677 # # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
al@912 678 # # is enabled and cook fails we have ERROR in log, if no auto cook we have
al@912 679 # # missing dep in cached file.
al@912 680 # lerror=$(_n 'ERROR')
al@912 681 # if fgrep -q ^$lerror $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
al@912 682 # [ -s "$CACHE/missing.dep" ] && nb=$(wc -l < $CACHE/missing.dep)
al@912 683 # _p 'ERROR: missing %d dependency' 'ERROR: missing %d dependencies' "$nb" "$nb"
al@912 684 # broken; exit 1
al@912 685 # fi
al@912 686 #
al@912 687 # # Install local packages: package-version$arch
al@912 688 # cd $PKGS
al@912 689 # for i in $(uniq $CACHE/installed.local); do
al@912 690 # # _ 'Installing dep (pkg/local): %s' "$i"
al@912 691 # tazpkg install $i --root=$root --local --quiet --cookmode
al@912 692 # done
al@912 693 #
al@912 694 # # Install web or cached packages (if mirror is set to $PKGS we only
al@912 695 # # use local packages).
al@912 696 # for i in $(uniq $CACHE/installed.web); do
al@912 697 # # _ 'Installing dep (web/cache): %s' "$i"
al@912 698 # tazpkg get-install $i --root=$root --local --quiet --cookmode
al@912 699 # done
pankso@358 700
al@769 701 update_installed_cook_diff
pankso@202 702
pankso@1 703 # Get source tarball and make sure we have source dir named:
paul@62 704 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 705 # tarball if it exists.
al@909 706 if [ -n "$WGET_URL" -a ! -f "$SRC/$TARBALL" ]; then
pankso@1 707 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
al@728 708 TARBALL="${SOURCE:-$PACKAGE}-$VERSION.tar.lzma"
al@728 709 LZMA_SRC=''
pankso@1 710 else
al@899 711 get_source || { broken; exit 1; }
pankso@1 712 fi
pankso@1 713 fi
al@909 714 if [ -z "$WANTED" -a -n "$TARBALL" -a ! -d "$src" ]; then
al@728 715 mkdir -p $pkgdir/source/tmp; cd $pkgdir/source/tmp
pascal@268 716 if ! extract_source ; then
pascal@268 717 get_source
al@899 718 extract_source || { broken; exit 1; }
pascal@268 719 fi
al@728 720 if [ -n "$LZMA_SRC" ]; then
pankso@190 721 cd $pkgdir/source
al@909 722 if [ "$(ls -A tmp | wc -l)" -gl 1 -o -f "$(echo tmp/*)" ]; then
al@728 723 mv tmp tmp-1; mkdir tmp
pankso@190 724 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
pankso@190 725 fi
pankso@190 726 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
al@728 727 cd tmp; tar -c * | lzma e $SRC/$TARBALL -si
pankso@190 728 fi
pankso@190 729 fi
al@1008 730
pankso@190 731 cd $pkgdir/source/tmp
paul@62 732 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 733 files=$(ls | wc -l)
al@1008 734 [ "$files" -eq 1 -a -d "$(ls)" ] &&
al@1008 735 mv * ../$PACKAGE-$VERSION
al@1008 736 [ "$files" -eq 1 -a -f "$(ls)" ] &&
al@1008 737 mkdir -p ../$PACKAGE-$VERSION &&
al@1008 738 mv * ../$PACKAGE-$VERSION/$TARBALL
al@1008 739 [ "$files" -gt 1 ] &&
al@1008 740 mkdir -p ../$PACKAGE-$VERSION &&
al@1008 741 mv * ../$PACKAGE-$VERSION
al@728 742 cd ..; rm -rf tmp
pankso@1 743 fi
pankso@662 744
al@1008 745 # Check md5sum (or similar) for sources tarball
al@909 746 check_integrity
al@909 747
pankso@658 748 # Libtool shared libs path hack.
pankso@658 749 case "$ARCH" in
pankso@658 750 arm*) cross libhack ;;
pankso@658 751 esac
pankso@1 752
al@1008 753 # Compiling all the sets
pankso@44 754 if grep -q ^compile_rules $receipt; then
al@728 755 _ 'Executing: %s' 'compile_rules'
pankso@352 756 echo "CFLAGS : $CFLAGS"
pankso@358 757 #echo "LDFLAGS : $LDFLAGS"
pankso@55 758 [ -d "$src" ] && cd $src
al@899 759 patchit
al@809 760
al@1008 761 # Get set names from $SPLIT variable, format ex. 'pkg1 pkg2:set1 pkg3:set2'
al@1008 762 SETS=$(echo $SPLIT \
al@1008 763 | awk '
al@1008 764 BEGIN { RS = " "; FS = ":"; }
al@1008 765 { print $2; }' \
al@1008 766 | sort -u \
al@1008 767 | tr '\n' ' ')
al@1008 768 SETS=${SETS% } # normalize space
al@1008 769 # Prepare specified source sets using patched sources
al@1008 770 [ -n "$SETS" ] &&
al@1008 771 for set in $SETS; do
al@1008 772 echo "Preparing set $set" # debug
al@1008 773 cp -a $src $src-$set
al@1008 774 done
al@912 775
al@1008 776 for SET in '' $SETS; do
al@1008 777 # Switch to the specified source set
al@1008 778 set_paths
al@1008 779 local suffix=''
al@1008 780 [ -n "$SET" ] && suffix="-$SET"
al@1008 781 export src="$WOK/$pkg/source/$PACKAGE-$VERSION$suffix"
al@1008 782 export install="$WOK/$pkg/install$suffix"
al@1008 783 export DESTDIR="$install"
al@1008 784
al@1008 785 if [ -n "$SETS" ]; then
al@1008 786 if [ -n "$SET" ]; then
al@1008 787 title "Switching to the set '$SET'"
al@1008 788 else
al@1008 789 title "Switching to the default set"
al@1008 790 fi
al@1008 791 echo "src : $src"
al@1008 792 echo "install: $install"
al@1008 793 fi
al@1015 794 [ -d "$src" ] && cd $src # packages without sources exists
al@1008 795 echo
al@1008 796
al@1008 797 [ -d "$install" ] && rm -r $install
al@1019 798 #mkdir -p $install
al@1008 799
al@1008 800 compile_rules $@ || { broken; exit 1; }
al@1008 801
al@1008 802 # Stay compatible with _pkg
al@1008 803 [ -d "$src/_pkg" ] && mv $src/_pkg $install
al@1008 804
al@1008 805 copy_generic_stuff
al@1008 806
al@1008 807 # Actions to do after compiling the package
al@1008 808 # Skip all for split packages (already done in main package)
al@1008 809 if [ -z "$WANTED" ]; then
al@1008 810 footer
al@1008 811 export COOKOPTS ARCH install
al@1008 812 @@PREFIX@@/libexec/cookutils/compressor install
al@1008 813 fi
al@1008 814 done
al@1013 815 else
al@1013 816 mkdir -p $install # allow receipts without `compile_rules()`
al@837 817 fi
al@779 818 footer
pankso@360 819
pankso@360 820 # Execute testsuite.
pankso@360 821 if grep -q ^testsuite $receipt; then
al@779 822 title 'Running testsuite'
al@899 823 testsuite $@ || { broken; exit 1; }
al@779 824 footer
pankso@360 825 fi
al@769 826
al@769 827 update_installed_cook_diff force
pankso@1 828 }
pankso@1 829
al@728 830
pankso@1 831 # Cook quality assurance.
al@728 832
pankso@1 833 cookit_quality() {
al@989 834 while true; do
al@989 835 [ ! -d "$WOK/$pkg/install" -a -z "$WANTED" ] || break
al@728 836 _ 'ERROR: cook failed' | tee -a $LOGS/$pkg.log
al@989 837 [ "$trials" == 'yes' ] || break
al@989 838 title "Interactive mode"
al@989 839 # TODO: allow commands:
al@989 840 # q - quit; v - edit receipt here using vi;
al@989 841 # s - search for package containing package;
al@989 842 # <package name> - install package; [Enter] - retry
al@989 843 _ 'You may install the packages here and/or edit the receipt there.'
al@989 844 newline
al@989 845 while true; do
al@989 846 _n 'Install the package? [name/N] '; read answer
al@989 847 [ -n "$answer" ] || break
al@989 848 tazpkg -gi $answer --root=$root --local --quiet --cookmode
al@989 849 done
al@989 850 newline
al@989 851 _n 'Try again? [Y/n] '; read answer
al@989 852 [ "$answer" == 'n' ] && break
paul@993 853 # here you may append log if you want (">>" instead of last ">")
al@989 854 cookit $@ 2>&1 | loglimit 50 > $LOGS/$pkg.log
al@989 855 done
al@962 856
al@962 857 [ "${COOKOPTS/skip-log-errors/}" != "$COOKOPTS" ] && return 0
al@962 858
pankso@9 859 # ERROR can be echoed any time in cookit()
pascal@618 860 if grep -Ev "(conftest|configtest)" $LOGS/$pkg.log | \
al@962 861 grep -Eq "(^ERROR|undefined reference to)" ; then
pankso@17 862 debug_info | tee -a $LOGS/$pkg.log
al@992 863 put_status $pkg Failed
al@728 864 rm -f $command
al@899 865 broken; exit 1
pankso@1 866 fi
pankso@1 867 }
pankso@1 868
al@728 869
al@728 870 # Create the package. Wanted to use TazPkg to create a tazpkg package at first,
paul@62 871 # but it doesn't handle EXTRAVERSION.
al@728 872
pankso@1 873 packit() {
al@904 874 set_paths "$1"
al@904 875 PACKAGE="${1:-$PACKAGE}"
pankso@359 876
pankso@359 877 # Handle cross compilation
pankso@359 878 case "$ARCH" in
pankso@676 879 arm*|x86_64) arch="-$ARCH" ;;
pankso@359 880 esac
pankso@359 881
al@779 882 title 'Pack: %s' "$PACKAGE $VERSION$arch"
pankso@359 883
pankso@44 884 if grep -q ^genpkg_rules $receipt; then
al@728 885 _ 'Executing: %s' 'genpkg_rules'
al@728 886 set -e; cd $pkgdir; mkdir -p $fs
al@728 887 genpkg_rules || (newline; _ 'ERROR: genpkg_rules failed'; newline) >> \
pankso@234 888 $LOGS/$pkg.log
pankso@241 889 else
al@728 890 _ 'No packages rules: meta package'
pankso@241 891 mkdir -p $fs
pankso@16 892 fi
pankso@98 893
al@859 894 # Check CONFIG_FILES
al@859 895 if [ -n "$CONFIG_FILES" ]; then
al@912 896 unset IFS
al@859 897 for i in $CONFIG_FILES; do
al@859 898 if [ ! -e $fs$i ]; then
al@859 899 case $i in
al@859 900 */) mkdir -p $fs$i ;;
al@859 901 *) mkdir -p $fs$(dirname $i); touch $fs$i ;;
al@859 902 esac
al@859 903 fi
al@859 904 done
al@859 905 fi
al@859 906
pankso@98 907 # First QA check to stop now if genpkg_rules failed.
al@728 908 lerror=$(_n 'ERROR')
pascal@613 909 if fgrep -q ^$lerror $LOGS/$pkg.log; then
al@899 910 broken; exit 1
pankso@98 911 fi
pankso@358 912
pankso@44 913 cd $taz
al@904 914 action 'Copying "%s"...' 'receipt'
al@1002 915 export PACKAGE DEPENDS PROVIDE SUGGESTED TAZPANEL_DAEMON TAGS CAT
al@1001 916 @@PREFIX@@/libexec/cookutils/mk_pkg_receipt "$(realpath ../receipt)" > $pack/receipt
al@904 917 chown 0.0 $pack/receipt; status
al@904 918
al@904 919 unset desc
al@904 920 [ "$pkg" == "$PACKAGE" -a -f "../description.txt" ] && desc="../description.txt"
al@904 921 [ -f "../description.$PACKAGE.txt" ] && desc="../description.$PACKAGE.txt"
al@904 922 if [ -n "$desc" ]; then
al@904 923 action 'Copying "%s"...' "$(basename "$desc")"
al@904 924 cp -f $desc $pack/description.txt; chown 0.0 $pack/description.txt; status
al@904 925 fi
al@904 926
pankso@119 927 copy_generic_files
pankso@358 928
pankso@119 929 # Strip and stuff files.
al@865 930 export COOKOPTS ARCH HOST_SYSTEM LOCALE fs; @@PREFIX@@/libexec/cookutils/compressor fs
pankso@43 931
al@728 932 # Create files.list with redirecting find output.
al@779 933 action 'Creating the list of files...'
al@728 934 cd $fs
al@951 935 find . -type f -print > ../files.list
al@728 936 find . -type l -print >> ../files.list
al@931 937 cd ..; sed -i 's|^.||' files.list
al@728 938 status
al@728 939
pankso@43 940 # Md5sum of files.
al@779 941 action 'Creating md5sum of files...'
pankso@16 942 while read file; do
pankso@16 943 [ -L "fs$file" ] && continue
pankso@16 944 [ -f "fs$file" ] || continue
pankso@16 945 case "$file" in
pankso@232 946 /lib/modules/*/modules.*|*.pyc) continue ;;
pankso@16 947 esac
al@931 948 md5sum "fs$file" | sed 's| fs| |'
al@953 949 done < files.list | sort -k2 > md5sum
pankso@16 950 status
al@728 951
al@728 952 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum description.txt \
al@728 953 2>/dev/null | awk 'END{ print $1 }')
pankso@358 954
al@904 955 # Build cpio archive.
al@779 956 action 'Compressing the FS...'
al@904 957 find fs -newer $receipt -exec touch -hr $receipt '{}' \;
al@969 958 find fs | cpio -o -H newc --quiet | lzma-alone e fs.cpio.lzma -si
al@969 959 # find fs | cpio -o -H newc --quiet | /bin/lzma -zeT0 -vv >fs.cpio.lzma
al@904 960 mv fs ../
pankso@16 961 status
al@728 962
al@728 963 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list md5sum description.txt \
al@728 964 2>/dev/null | awk 'END{ print $1 }')
al@728 965
al@779 966 action 'Updating receipt sizes...'
al@931 967 sed -i '/^PACKED_SIZE=/d; /^UNPACKED_SIZE=/d' receipt
al@931 968 sed -i "s|^PACKAGE=|PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=|" receipt
pankso@16 969 status
pankso@16 970
pankso@16 971 # Set extra version.
al@728 972 if [ -n "$EXTRAVERSION" ]; then
al@779 973 action 'Updating receipt EXTRAVERSION: %s' "$EXTRAVERSION"
al@931 974 sed -i '/^EXTRAVERSION=/d' receipt
al@931 975 sed -i "s|^VERSION=|EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=|" receipt
pankso@16 976 status
pankso@16 977 fi
pankso@16 978
pankso@16 979 # Compress.
al@779 980 action 'Creating full cpio archive...'
al@904 981 find . -newer $receipt -exec touch -hr $receipt '{}' \;
al@904 982 find . | cpio -o -H newc --quiet > ../$PACKAGE-$VERSION$EXTRAVERSION$arch.tazpkg
pankso@16 983 status
al@728 984
al@1010 985 # Restoring original package tree.
al@904 986 mv ../fs .
al@728 987
al@728 988 rm fs.cpio.lzma; cd ..
pankso@43 989
pankso@43 990 # QA and give info.
pankso@43 991 tazpkg=$(ls *.tazpkg)
pankso@43 992 packit_quality
al@779 993 footer "$(_ 'Package "%s" created' "$tazpkg")"
al@932 994 update_packages_db
pankso@1 995 }
pankso@1 996
al@728 997
al@952 998 # Calculate release checksum: usually it does not change on "just recook".
al@952 999 # Release checksum is md5sum of file containing md5sums of:
al@952 1000 # a) all files, b) receipt, and c) description.txt.
al@952 1001 # Md5sum of the package file will change every time because of embedded timestamps;
al@952 1002 # release checksum based only on files content, and will change only when files change.
al@952 1003 # (Pitfall: ownership and permissions...)
al@952 1004
al@952 1005 release_checksum() {
al@952 1006 local pack=$1
al@952 1007 local rsum_file=$(mktemp)
al@952 1008
al@952 1009 cp $pack/md5sum $rsum_file
al@952 1010 md5sum $pack/receipt | sed 's| [^ ]*/| |' >> $rsum_file
al@952 1011 [ -e "$pack/description.txt" ] &&
al@952 1012 md5sum $pack/description.txt | sed 's| [^ ]*/| |' >> $rsum_file
al@952 1013
al@952 1014 local rsum=$(md5sum $rsum_file | awk '{print $1}')
al@952 1015 rm $rsum_file
al@952 1016 local rsumold=$(awk -F$'\t' -vpkg="$PACKAGE" '
al@952 1017 {if ($1 == pkg) { print $9; exit; }}' $PKGS/packages.info)
al@952 1018
al@952 1019 [ "$rsum" == "$rsumold" ] && rsum=''
al@952 1020
al@952 1021 echo $rsum
al@952 1022 }
al@952 1023
al@952 1024
paul@62 1025 # Verify package quality and consistency.
al@728 1026
pankso@8 1027 packit_quality() {
al@779 1028 #action 'QA: checking for broken link...'
pankso@157 1029 #link=$(find $fs/usr -type l -follow)
pankso@157 1030 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@157 1031 #status
pankso@358 1032
al@969 1033 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ]; then
al@969 1034 # Exit if any error found in log file.
al@969 1035 if fgrep -q ^ERROR $LOGS/$pkg.log; then
al@969 1036 rm -f $command
al@969 1037 broken; exit 1
al@969 1038 fi
pankso@8 1039 fi
pankso@358 1040
al@1012 1041 [ -n "$CAT" ] && CATEGORY="${CAT%|*}" # allow meta-packages in v2 receipts
al@1012 1042
al@969 1043 if [ "${COOKOPTS/empty-pkg/}" == "$COOKOPTS" ]; then
al@969 1044 action 'QA: checking for empty package...'
al@969 1045 if [ ! -s "$pack/files.list" -a "$CATEGORY" != 'meta' ]; then
al@969 1046 broken
al@969 1047 rm -f $command
al@969 1048 false; status
al@969 1049 die 'ERROR: empty package'
al@969 1050 fi
al@969 1051 :; status
pankso@8 1052 fi
al@899 1053
al@952 1054
al@952 1055 # Find and remove old package(s) only if "release checksum" has changed
al@952 1056 rsum=$(release_checksum $pack)
al@952 1057 if [ -n "$rsum" ]; then
al@952 1058 old_file=$(awk -F$'\t' -vname="$PACKAGE" '{
al@952 1059 if ($1 == name) printf("%s-%s.tazpkg", $1, $2);
al@952 1060 }' $PKGS/packages.info)
al@952 1061 if [ -f "$PKGS/$old_file" ]; then
al@952 1062 action 'Removing old package "%s"' "$old_file"
al@952 1063 rm -f "$PKGS/$old_file"
al@899 1064 status
al@899 1065 fi
al@954 1066 # package changed, substitute old package by new
al@952 1067 mv -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg $PKGS
al@954 1068 else
al@954 1069 # package not changed, remove new package
al@954 1070 rm -f $pkgdir/taz/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg
al@952 1071 fi
al@952 1072
al@931 1073 sed -i "/^${pkg}$/d" $broken
al@899 1074 #action 'Removing source tree...'
al@899 1075 #rm -f $WOK/$pkg/source; status
pankso@8 1076 }
pankso@8 1077
al@728 1078
al@916 1079 # Return all the names of packages bundled in this receipt
al@916 1080
al@916 1081 all_names() {
al@1008 1082 # Get package names from $SPLIT variable
al@1008 1083 local split=$(echo $SPLIT \
al@1008 1084 | awk '
al@1008 1085 BEGIN { RS = " "; FS = ":"; }
al@1008 1086 { print $1; }' \
al@1008 1087 | tr '\n' ' ')
al@1008 1088 local split_space=" $split "
al@940 1089 if ! head -n1 $WOK/$pkg/receipt | fgrep -q 'v2'; then
al@940 1090 # For receipts v1: $SPLIT may present in the $WANTED package,
al@940 1091 # but split packages have their own receipts
al@940 1092 echo $PACKAGE
al@1008 1093 elif [ "${split_space/ $PACKAGE /}" != "$split_space" ]; then
al@916 1094 # $PACKAGE included somewhere in $SPLIT (probably in the end).
al@916 1095 # We should build packages in the order defined in the $SPLIT.
al@1008 1096 echo $split
al@916 1097 else
al@916 1098 # We'll build the $PACKAGE, then all defined in the $SPLIT.
al@1008 1099 echo $PACKAGE $split
al@916 1100 fi
al@916 1101 }
al@916 1102
al@916 1103
al@904 1104 # v2: pack all packages using compiled files
al@904 1105
al@904 1106 packall() {
al@904 1107 set_paths
al@904 1108 if head -n1 "$pkgdir/receipt" | fgrep -q 'v2'; then
al@916 1109 for i in $(all_names); do
al@913 1110 unset TAGS DEPENDS CAT CONFIG_FILES PROVIDE SUGGESTED DATABASE_FILES TAZPANEL_DAEMON
al@904 1111 packit $i
al@904 1112 done
al@904 1113 else
al@904 1114 packit
al@904 1115 fi
al@904 1116 }
al@904 1117
al@904 1118
al@728 1119 # Reverse "cat" command: prints input lines in the reverse order
al@728 1120
pankso@421 1121 tac() {
pascal@285 1122 sed '1!G;h;$!d' $1
pascal@285 1123 }
pascal@285 1124
al@728 1125
al@907 1126 # Update chroot with freshly rebuilt package: keep env up-to-date.
al@907 1127
al@907 1128 update_chroot() {
al@923 1129 local PACKAGE="$pkg"
al@923 1130 for i in $(all_names); do
al@907 1131 if [ -d "$root$INSTALLED/$i" ]; then
al@907 1132 . /etc/slitaz/cook.conf
al@1004 1133 . $WOK/$pkg/taz/$i-$VERSION$EXTRAVERSION/receipt
al@907 1134 _ 'Updating %s chroot environment...' "$ARCH"
al@907 1135 _ 'Updating chroot: %s' "$i ($VERSION$EXTRAVERSION$arch)" | log
al@907 1136 cd $PKGS
al@907 1137 tazpkg install $i-$VERSION$EXTRAVERSION$arch.tazpkg --forced --root=$root
al@907 1138 fi
al@907 1139 done
al@907 1140 }
al@907 1141
al@907 1142
al@907 1143 # Install package on --inst or update the chroot.
al@728 1144
pankso@428 1145 install_package() {
al@953 1146 set_paths
pankso@428 1147 case "$ARCH" in
pankso@676 1148 arm*|x86_64)
al@737 1149 arch="-$ARCH"
al@728 1150 root="$CROSS_TREE/sysroot" ;;
pankso@428 1151 esac
pankso@428 1152 # Install package if requested but skip install if target host doesn't
pankso@428 1153 # match build system or it will break the build chroot.
al@728 1154 build=$(echo $BUILD_SYSTEM | cut -d- -f1)
al@907 1155 if [ -n "$inst" -a "$build" == "$ARCH" ]; then
al@737 1156 if [ -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
al@728 1157 cd $PKGS
al@728 1158 tazpkg install $PACKAGE-$VERSION$EXTRAVERSION.tazpkg --forced
pankso@428 1159 else
al@899 1160 broken
al@899 1161 die 'Unable to install package, build has failed.'
pankso@428 1162 fi
pankso@428 1163 fi
pankso@428 1164
al@907 1165 update_chroot
pankso@428 1166 }
pankso@428 1167
al@728 1168
pascal@696 1169 # remove chroot jail
al@728 1170
pascal@696 1171 umount_aufs() {
pascal@696 1172 tac ${1}rw/aufs-umount.sh | sh
pascal@696 1173 rm -rf ${1}rw
pascal@696 1174 umount ${1}root
pascal@697 1175 rmdir ${1}r*
pascal@696 1176 }
pascal@696 1177
al@728 1178
pascal@285 1179 # Launch the cook command into a chroot jail protected by aufs.
pascal@285 1180 # The current filesystems are used read-only and updates are
pascal@285 1181 # stored in a separate branch.
al@728 1182
pascal@285 1183 try_aufs_chroot() {
pascal@285 1184
al@728 1185 base="/dev/shm/aufsmnt$$"
pascal@286 1186
al@596 1187 # Can we setup the chroot? Is it already done?
pascal@292 1188 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
al@728 1189 grep -q ^AUFS_NOT_RAMFS $receipt && base="/mnt/aufsmnt$$"
pascal@285 1190 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
pascal@875 1191 grep -q ^aufs /proc/modules || modprobe aufs 2> /dev/null || return
pascal@286 1192 mkdir ${base}root ${base}rw || return
pascal@285 1193
al@728 1194 _ 'Setup aufs chroot...'
pascal@285 1195
pascal@285 1196 # Sanity check
pascal@286 1197 for i in / /proc /sys /dev/shm /home ; do
pascal@285 1198 case " $AUFS_MOUNTS " in
pascal@285 1199 *\ $i\ *) ;;
pascal@285 1200 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
pascal@285 1201 esac
pascal@285 1202 done
pascal@691 1203 for mnt in $(ls -d $AUFS_MOUNTS | sort | uniq); do
pascal@285 1204 mount --bind $mnt ${base}root$mnt
pascal@285 1205 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
al@728 1206 _ 'Aufs mount failure'
slaxemulator@519 1207 umount ${base}root
pascal@628 1208 rm -rf ${base}r*
slaxemulator@519 1209 return
pascal@285 1210 fi
pascal@285 1211 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
pascal@285 1212 done
pascal@696 1213 trap "umount_aufs ${base}" INT
pascal@285 1214
pascal@285 1215 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
pascal@285 1216 status=$?
pascal@285 1217
al@728 1218 _ 'Leaving aufs chroot...'
al@737 1219 umount_aufs $base
pascal@683 1220 # Install package outside the aufs jail
pascal@683 1221 install_package
pankso@358 1222 exit $status
pascal@285 1223 }
pascal@285 1224
al@728 1225
al@705 1226 # Encode predefined XML entities
al@728 1227
al@705 1228 xml_ent() {
al@705 1229 sed -e 's|&|\&amp;|g; s|<|\&lt;|g; s|>|\&gt;|g; s|"|\&quot;|g' -e "s|'|\&apos;|g"
al@705 1230 }
al@705 1231
al@728 1232
paul@387 1233 # Create a XML feed for freshly built packages.
al@728 1234
pankso@310 1235 gen_rss() {
al@728 1236 pubdate=$(date '+%a, %d %b %Y %X')
al@728 1237 cat > $FEEDS/$pkg.xml <<EOT
pankso@310 1238 <item>
al@737 1239 <title>$PACKAGE $VERSION$EXTRAVERSION</title>
al@899 1240 <link>${COOKER_URL}?pkg=${PACKAGE//+/%2B}</link>
al@737 1241 <guid>$PACKAGE-$VERSION$EXTRAVERSION</guid>
pankso@310 1242 <pubDate>$pubdate</pubDate>
al@705 1243 <description>$(echo -n "$SHORT_DESC" | xml_ent)</description>
pankso@310 1244 </item>
pankso@310 1245 EOT
pankso@310 1246 }
pankso@310 1247
al@728 1248
pankso@662 1249 # Truncate stdout log file to $1 Mb.
al@728 1250
al@728 1251 loglimit() {
pascal@593 1252 if [ -n "$DEFAULT_LOG_LIMIT" ]; then
pascal@621 1253 tee /dev/stderr | head -qc ${1:-$DEFAULT_LOG_LIMIT}m
pascal@593 1254 else
pascal@593 1255 tee /dev/stderr
pascal@593 1256 fi
pascal@576 1257 }
pascal@576 1258
al@728 1259
pankso@1 1260 #
pankso@671 1261 # Receipt functions to ease packaging
pankso@671 1262 #
pankso@671 1263
pankso@671 1264 get_dev_files() {
al@779 1265 action 'Getting standard devel files...'
pankso@671 1266 mkdir -p $fs/usr/lib
pankso@671 1267 cp -a $install/usr/lib/pkgconfig $fs/usr/lib
pascal@750 1268 cp -a $install/usr/lib/*a $fs/usr/lib
pankso@671 1269 cp -a $install/usr/include $fs/usr
pankso@671 1270 status
pankso@671 1271 }
pankso@671 1272
al@807 1273
al@809 1274 # Function to use in compile_rules() to copy man page from $src to $install
al@807 1275
al@809 1276 cook_pick_manpages() {
al@809 1277 local name section
al@809 1278 action 'Copying man pages...'
al@802 1279
al@809 1280 for i in $@; do
al@809 1281 name=$(echo $i | sed 's|\.[gbx]z2*$||')
al@809 1282 section=${name##*/}; section=${section##*.}
al@809 1283 mkdir -p $install/usr/share/man/man$section
al@899 1284 scopy $i $install/usr/share/man/man$section
al@802 1285 done
al@802 1286 status
al@802 1287 }
al@802 1288
al@807 1289
al@962 1290 # Function to use in compile_rules() to copy documentation from $src to $install
al@962 1291
al@962 1292 cook_pick_docs() {
al@962 1293 local docdir="$install/usr/share/doc/$PACKAGE-$VERSION"
al@962 1294 action 'Copying documentation...'
al@962 1295 mkdir -p $docdir
al@962 1296 cp -r $@ $docdir
al@962 1297 chmod -R a+r $docdir
al@962 1298 status
al@962 1299 }
al@962 1300
al@962 1301
al@807 1302 # Function to use in genpkg_rules() to copy specified files from $install to $fs
al@807 1303
al@802 1304 cook_copy_files() {
al@802 1305 action 'Copying files...'
al@802 1306 cd $install
al@802 1307 local i j
al@880 1308 IFS=$'\n'
al@802 1309 for i in $@; do
al@802 1310 for j in $(find . -name $i ! -type d); do
al@899 1311 mkdir -p $fs$(dirname ${j#.})
al@899 1312 scopy $j $fs$(dirname ${j#.})
al@802 1313 done
al@802 1314 done
al@802 1315 cd - >/dev/null
al@802 1316 status
al@802 1317 }
al@802 1318
al@807 1319
al@834 1320 # Function to use in genpkg_rules() to copy specified folders from $install to $fs
al@834 1321
al@834 1322 cook_copy_folders() {
al@834 1323 action 'Copying folders...'
al@834 1324 cd $install
al@834 1325 local i j
al@880 1326 IFS=$'\n'
al@834 1327 for i in $@; do
al@834 1328 for j in $(find . -name $i -type d); do
al@899 1329 mkdir -p $fs$(dirname ${j#.})
al@899 1330 cp -a $j $fs$(dirname ${j#.})
al@834 1331 done
al@834 1332 done
al@834 1333 cd - >/dev/null
al@834 1334 status
al@834 1335 }
al@834 1336
al@834 1337
paul@993 1338 # Remove from current $fs files that are already packed (for receipts v2).
al@989 1339 # Note: the order in $SPLIT is very important.
al@1010 1340 # Note 2: working in the current set.
al@989 1341
al@989 1342 remove_already_packed() {
al@989 1343 local i j
al@1019 1344 # $pkg is the name of the main package; $PACKAGE is the name of the current one
al@1019 1345 # $pkg may (or may not) be included in the $SPLIT
al@1010 1346 neighbors=$(
al@1019 1347 echo $pkg $SPLIT" " \
al@1010 1348 | awk -F$'\t' -vpkg="$PACKAGE" '
al@1010 1349 BEGIN { RS = " "; FS = ":"; }
al@1010 1350 { set[$1] = $2; }
al@1010 1351 END {
al@1010 1352 current_set = set[pkg];
al@1010 1353 for (i in set)
al@1010 1354 { if (i != pkg && set[i] == current_set) print i; }
al@1010 1355 }
al@1010 1356 ')
al@989 1357 IFS=$'\n'
al@1010 1358 for neighbor in $neighbors; do
al@1010 1359 i="$taz/$neighbor-$VERSION$EXTRAVERSION/files.list"
al@989 1360 [ -e "$i" ] || continue
al@989 1361 while read j; do
al@989 1362 [ -f $fs$j -o -h $fs$j ] || continue
al@989 1363 rm $fs$j
al@989 1364 rmdir --parents --ignore-fail-on-non-empty $fs$(dirname $j)
al@989 1365 done < $i
al@989 1366 done
al@989 1367 unset IFS
al@989 1368 }
al@989 1369
al@989 1370
al@1008 1371 # Function to use in genpkg_rules() to copy hicolor icons in specified sizes
al@1008 1372 # (default: 16 and 48) from $install to $fs
al@1008 1373
al@1008 1374 cook_copy_icons() {
al@1018 1375 local sizes=$@ i j ifs="$IFS"
al@1018 1376 unset IFS
al@1008 1377 action 'Copying hicolor icons...'
al@1008 1378 [ -d "$fs/usr/share/icons/hicolor" ] && rm -rf "$fs/usr/share/icons/hicolor"
al@1008 1379 mkdir -p $fs/usr/share/icons/hicolor
al@1008 1380 for i in ${sizes:-16 48}; do
al@1008 1381 j="${i}x$i"; [ "$i" == 'scalable' ] && j="$i"
al@1008 1382 [ ! -e "$install/usr/share/icons/hicolor/$j" ] ||
al@1008 1383 scopy $install/usr/share/icons/hicolor/$j \
al@1008 1384 $fs/usr/share/icons/hicolor
al@1008 1385 done
al@1008 1386 status
al@1018 1387 IFS="$ifs"
al@1008 1388 }
al@1008 1389
al@1008 1390
al@899 1391 # Common function to copy files, folders and patterns
al@899 1392
al@899 1393 copy() {
al@899 1394 action 'Copying folders and files...'
al@963 1395 local i j k filelist=$(mktemp) folderlist=$(mktemp)
al@1008 1396
al@1008 1397 # Get set name for specified package from $SPLIT variable
al@1008 1398 local set=$(echo $SPLIT \
al@1008 1399 | awk -vpkg="$PACKAGE" '
al@1008 1400 BEGIN { RS = " "; FS = ":"; }
al@1009 1401 { if ($1 == pkg && $2) { print "-" $2; exit; } }')
al@1008 1402 # Change set, make filelist and folderlist for new set
al@1008 1403 export src="$WOK/$pkg/source/$PACKAGE-$VERSION$set"
al@1008 1404 export install="$WOK/$pkg/install$set"
al@1008 1405 export DESTDIR="$install"
al@899 1406 IFS=$'\n'
al@963 1407 cd $install
al@963 1408 find ! -type d | sed 's|\.||' > $filelist
al@963 1409 find -type d | sed 's|\.||' > $folderlist
al@1008 1410
al@899 1411 for i in $@; do
al@899 1412 case $i in
al@899 1413 @std)
al@899 1414 # Copy "standard" files (all but "developer files", man pages, documentation, translations)
al@980 1415 sed '/\.h$/d; /\.hxx$/d; /\.a$/d; /\.la$/d; /\.pc$/d; /\.pri$/d; /bin\/.*-config$/d;
al@905 1416 /\.m4$/d; /\.gir$/d; /\.typelib$/d; /\.vapi$/d; /\.deps$/d; /\.cmake$/d;
al@924 1417 /\/Makefile.*/d; /\.inc$/d; /\/include\//d;
al@904 1418 /\/share\/man\//d; /\/share\/doc\//d; /\/share\/gtk-doc\//d; /\/share\/info\//d;
al@904 1419 /\/share\/devhelp\//d; /\/share\/locale\//d;
al@904 1420 /\/share\/bash-completion\//d; /\/lib\/systemd\//d;
al@945 1421 /\/fonts\.scale$/d; /\/fonts\.dir$/d;
al@989 1422 /\/share\/appdata\//d; /\/share\/help\//d;
al@1003 1423 /\/share\/icons\/hicolor\/[12356][1245][268]*x[12356][1245][268]*\//d; # 22, 24, 32, 64, 128, 256, 512
al@912 1424 ' $filelist
al@899 1425 ;;
al@899 1426 @dev)
al@899 1427 # Copy "developer files"
al@980 1428 sed -n '/\.h$/p; /\.hxx$/p; /\.a$/p; /\.la$/p; /\.pc$/p; /\.pri$/p; /bin\/.*-config$/p;
al@905 1429 /\.m4$/p; /\.gir$/p; /\.typelib$/p; /\.vapi$/p; /\.deps$/p; /\.cmake$/p;
al@924 1430 /\/Makefile.*/p; /\.inc$/p; /\/include\//p;
al@912 1431 ' $filelist
al@899 1432 ;;
al@989 1433 @rm)
al@1008 1434 # Quick alias
al@989 1435 remove_already_packed
al@989 1436 ;;
al@1008 1437 @ico)
al@1008 1438 # Quick alias
al@1008 1439 cook_copy_icons >/dev/null
al@1008 1440 ;;
al@899 1441 */)
al@912 1442 # Copy specified folders.
al@912 1443 i="${i%/}"
al@912 1444 find -type d -path "*/${i#/}" | sed 's|^.||'
al@899 1445 ;;
al@899 1446 *)
al@912 1447 # Copy specified files.
al@912 1448 find ! -type d -path "*/${i#/}" | sed 's|^.||'
al@899 1449 ;;
al@1008 1450 esac \
al@1008 1451 | sort -u \
al@1008 1452 | while read j; do
al@912 1453 mkdir -p $fs$(dirname "$j")
al@912 1454 if [ -d "$install$j" ]; then
al@912 1455 cp -a "$install$j" $fs$(dirname "$j")
al@912 1456 else
al@912 1457 scopy "$install$j" $fs$(dirname "$j")
al@912 1458 fi
al@912 1459 done
al@963 1460 # Copy empty directories
al@963 1461 case $i in
al@963 1462 @std)
al@963 1463 while read j; do
al@966 1464 case $j in
al@1003 1465 # always skip empty man & doc folders, because this will end up
al@1003 1466 # copying all the man pages and docs to the package
al@1003 1467 */man/*|*/doc/*) continue;;
al@966 1468 esac
al@966 1469 [ -z "$(ls -A "$install$j")" ] || continue
al@963 1470 # directory $j is empty
al@963 1471 k="$j"
al@963 1472 # make 'ladder' from directories, from root dir to $j
al@963 1473 # /a /a/b /a/b/c etc.
al@963 1474 while :; do
al@963 1475 [ -z "$k" ] && break
al@963 1476 echo "$k"
al@963 1477 k="${k%/*}"
al@1008 1478 done \
al@1008 1479 | tac \
al@1008 1480 | while read k; do
al@1008 1481 # copy dir with its original ownership/permissions if it does not exist
al@963 1482 [ -d "$fs$k" ] || cp -a "$install$k" "$fs$k"
al@963 1483 done
al@963 1484 done < $folderlist
al@963 1485 ;;
al@963 1486 esac
al@899 1487 done
al@899 1488 cd - >/dev/null
al@912 1489 unset IFS
al@963 1490 rm $filelist $folderlist
al@899 1491 status
al@899 1492 }
al@899 1493
al@899 1494
al@932 1495 # Update packages database every time after successful build
al@899 1496
al@932 1497 update_packages_db() {
al@932 1498 # packages.info (unsorted, located near to packages)
al@932 1499 local pi="$PKGS/packages.info"
al@899 1500 unset_receipt; . $pack/receipt
al@899 1501 SIZES=$(echo $PACKED_SIZE $UNPACKED_SIZE | sed 's|\.0||g')
al@945 1502
al@904 1503 DEPENDS=$(echo $DEPENDS) # remove newlines, tabs and multiple spaces from variable
al@945 1504
al@952 1505 rsum=$(release_checksum $pack)
al@952 1506 if [ -n "$rsum" ]; then
al@952 1507 _ 'The release checksum has changed.\n'
al@945 1508
al@952 1509 sed -i "/^$PACKAGE\t/d" $pi # remove old entry
al@952 1510 cat >> $pi <<EOT
al@945 1511 $PACKAGE $VERSION$EXTRAVERSION $CATEGORY $SHORT_DESC $WEB_SITE $TAGS $SIZES $DEPENDS $rsum $PROVIDE
al@899 1512 EOT
al@899 1513
al@952 1514 # files.list (uncompressed, unsorted, located in $cache)
al@952 1515 local fl="$cache/files.list"
al@952 1516 touch $fl
al@952 1517 sed -i "/^$PACKAGE: /d" $fl
al@952 1518 sed "s/^/$PACKAGE: \0/" $pack/files.list >> $fl
al@952 1519 else
al@952 1520 _ 'The release checksum has not changed.\n'
al@952 1521 fi
al@932 1522 }
al@932 1523
al@932 1524
al@932 1525 # Update split.db once for receipt
al@932 1526
al@932 1527 update_split_db() {
al@932 1528 local db="$cache/split.db"
al@932 1529 touch $db
al@932 1530 sed -i "/^$pkg\t/d" $db
al@932 1531 echo -e "$pkg\t$(all_names)" >> $db
al@932 1532 }
al@932 1533
al@932 1534
al@932 1535 # Recreate whole split.db from scratch
al@932 1536
al@932 1537 recreate_split_db() {
al@932 1538 # Clean
al@932 1539 local db="$cache/split.db"
al@932 1540 touch $db
al@932 1541 > $db
al@932 1542
al@932 1543 cd $WOK
al@940 1544 for pkg in *; do
al@940 1545 [ -f "$WOK/$pkg/receipt" ] || continue
al@932 1546 unset PACKAGE SPLIT
al@940 1547 . $WOK/$pkg/receipt
al@932 1548 echo -e "$PACKAGE\t$(all_names)" >> $db
al@932 1549 done
al@899 1550 }
al@899 1551
al@899 1552
al@992 1553 # Put the status to the activity log
al@992 1554
al@992 1555 put_status() {
al@992 1556 # $1: package, $2: status, one of 'Done', 'Failed'
al@992 1557 sed -i "s|>$1</a>$|& [ $2 ]|" $activity
al@992 1558 }
al@992 1559
al@992 1560
al@742 1561
al@728 1562
pankso@671 1563 #
pankso@1 1564 # Commands
pankso@1 1565 #
pankso@1 1566
al@932 1567 # cook <package> --deps
al@933 1568 [ -n "$deps" ] && {
al@933 1569 @@PREFIX@@/libexec/cookutils/deps $1
al@933 1570 exit 0
al@933 1571 }
al@933 1572
al@933 1573 # cook <package> --clean
al@933 1574 # cook <package> -c
al@933 1575 [ -n "$clean" -o "$2" == '-c' ] && {
al@933 1576 action 'Cleaning "%s"' "$1"
al@933 1577 cd $WOK/$1; rm -rf install taz source
al@933 1578 status; newline
al@933 1579 touch $activity # update $activity -> something changed -> update webstat
al@933 1580 exit 0
al@933 1581 }
al@933 1582
al@933 1583 # cook <package> --getsrc
al@933 1584 # cook <package> -gs
al@933 1585 [ -n "$getsrc" -o "$2" == '-gs' ] && {
al@933 1586 title 'Getting source for "%s"' "$1"
al@933 1587 receipt="$WOK/$pkg/receipt"
al@933 1588 check_pkg_in_wok
al@933 1589 unset_receipt
al@933 1590 . $receipt
al@933 1591 get_source
al@933 1592 _ 'Tarball: %s' "$SRC/$TARBALL"; newline
al@933 1593 exit 0
al@933 1594 }
al@933 1595
al@933 1596 # cook <package> --block
al@933 1597 # cook <package> -b
al@933 1598 [ -n "$block" -o "$2" == '-b' ] && {
al@933 1599 action 'Blocking package "%s"' "$1"
al@933 1600 [ $(grep "^$1$" $blocked) ] || echo "$1" >> $blocked
al@933 1601 status; newline
al@933 1602 touch $activity
al@933 1603 exit 0
al@933 1604 }
al@933 1605
al@933 1606 # cook <package> --unblock
al@933 1607 # cook <package> -ub
al@933 1608 [ -n "$unblock" -o "$2" == '-ub' ] && {
al@933 1609 action 'Unblocking package "%s"' "$1"
al@933 1610 sed -i "/^$1$/d" $blocked
al@933 1611 status; newline
al@933 1612 touch $activity
al@933 1613 exit 0
al@933 1614 }
al@933 1615
al@933 1616
al@932 1617
al@932 1618
pankso@1 1619 case "$1" in
pankso@32 1620 usage|help|-u|-h)
pankso@1 1621 usage ;;
al@728 1622
pankso@1 1623 list-wok)
al@779 1624 title 'List of %s packages in "%s"' "$ARCH" "$WOK"
pankso@642 1625 cd $WOK
al@728 1626 if [ "$ARCH" != 'i486' ]; then
pankso@643 1627 count=0
al@728 1628 for pkg in $(fgrep 'HOST_ARCH=' */receipt | egrep "$ARCH|any" | cut -d: -f1)
pankso@643 1629 do
pankso@643 1630 unset HOST_ARCH
al@951 1631 . ./$pkg
pankso@643 1632 count=$(($count + 1))
pankso@643 1633 colorize 34 "$PACKAGE"
pankso@643 1634 done
pankso@642 1635 else
pankso@643 1636 count=$(ls | wc -l)
pankso@643 1637 ls -1
pankso@642 1638 fi
al@779 1639 footer "$(_p '%s package' '%s packages' "$count" "$(colorize 32 "$count")")"
al@779 1640 ;;
al@728 1641
pankso@378 1642 activity)
pankso@378 1643 cat $activity ;;
al@728 1644
pankso@69 1645 search)
al@931 1646 # Just a simple search function, we don't need more actually.
pankso@69 1647 query="$2"
al@779 1648 title 'Search results for "%s"' "$query"
al@728 1649 cd $WOK; ls -1 | grep "$query"
al@779 1650 footer ;;
al@728 1651
pankso@1 1652 setup)
pankso@1 1653 # Setup a build environment
pankso@1 1654 check_root
al@728 1655 _ 'Cook: setup environment' | log
al@779 1656 title 'Setting up your environment'
psychomaniak@821 1657 [ -d $SLITAZ ] || mkdir -p $SLITAZ
al@596 1658 cd $SLITAZ
pankso@52 1659 init_db_files
al@728 1660 _ 'Checking for packages to install...'
pankso@397 1661 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
pankso@645 1662 # ARCH-setup or 'cross check' should be used before: cook setup
pankso@397 1663 case "$ARCH" in
pankso@676 1664 arm*|x86_64)
al@899 1665 [ -x '/usr/bin/cross' ] || die 'ERROR: %s is not installed' 'cross'
al@728 1666 _ 'Using config file: %s' '/etc/slitaz/cross.conf'
pankso@397 1667 . /etc/slitaz/cross.conf ;;
pankso@397 1668 esac
pankso@397 1669 for pkg in $SETUP_PKGS; do
al@728 1670 if [ -n "$forced" ]; then
pankso@421 1671 tazpkg -gi $pkg --forced
pankso@397 1672 else
al@728 1673 [ ! -d "$INSTALLED/$pkg" ] && tazpkg get-install $pkg
pankso@397 1674 fi
pankso@397 1675 done
pankso@1 1676
pankso@1 1677 # Handle --options
pankso@1 1678 case "$2" in
al@728 1679 --wok) hg clone $WOK_URL wok || exit 1 ;;
al@728 1680 --stable) hg clone $WOK_URL-stable wok || exit 1 ;;
al@728 1681 --undigest) hg clone $WOK_URL-undigest wok || exit 1 ;;
al@728 1682 --tiny) hg clone $WOK_URL-tiny wok || exit 1 ;;
pankso@1 1683 esac
pankso@1 1684
pankso@1 1685 # SliTaz group and permissions
pankso@1 1686 if ! grep -q ^slitaz /etc/group; then
al@728 1687 _ 'Adding group "%s"' 'slitaz'
pankso@1 1688 addgroup slitaz
pankso@1 1689 fi
al@728 1690 _ 'Setting permissions for group "%s"...' 'slitaz'
pascal@277 1691 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
pascal@277 1692 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
al@779 1693 footer "$(_ 'All done, ready to cook packages :-)')" ;;
al@728 1694
pankso@395 1695 *-setup)
pankso@395 1696 # Setup for cross compiling.
al@728 1697 arch="${1%-setup}"
pankso@397 1698 check_root
pankso@644 1699 . /etc/slitaz/cook.conf
pankso@644 1700 for pkg in $CROSS_SETUP; do
al@728 1701 if [ -n "$forced" ]; then
pankso@644 1702 tazpkg -gi $pkg --forced
pankso@644 1703 else
al@728 1704 [ ! -d "$INSTALLED/$pkg" ] && tazpkg -gi $pkg
pankso@644 1705 fi
pankso@644 1706 done
al@728 1707
al@728 1708 _ 'Cook: setup %s cross environment' "$arch" | log
al@779 1709 title 'Setting up your %s cross environment' "$arch"
pankso@397 1710 init_db_files
pankso@359 1711 sed -i \
al@931 1712 -e "s|ARCH=.*|ARCH=\"$arch\"|" \
al@931 1713 -e "s|CROSS_TREE=.*|CROSS_TREE=\"/cross/$arch\"|" \
al@931 1714 -e 's|BUILD_SYSTEM=.*|BUILD_SYSTEM=i486-slitaz-linux|' \
pankso@395 1715 /etc/slitaz/cook.conf
pankso@395 1716 case "$arch" in
pankso@395 1717 arm)
al@728 1718 flags='-O2 -march=armv6'
pankso@650 1719 host="$ARCH-slitaz-linux-gnueabi" ;;
pankso@650 1720 armv6hf)
al@728 1721 flags='-O2 -march=armv6j -mfpu=vfp -mfloat-abi=hard'
pankso@650 1722 host="$ARCH-slitaz-linux-gnueabi" ;;
pankso@650 1723 armv7)
al@728 1724 flags='-Os -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=softfp -pipe'
pankso@650 1725 host="$ARCH-slitaz-linux-gnueabi" ;;
pankso@395 1726 x86_64)
al@728 1727 flags='-O2 -mtune=generic -pipe'
pankso@650 1728 host="$ARCH-slitaz-linux" ;;
pankso@395 1729 esac
pankso@650 1730 sed -i \
al@931 1731 -e "s|CFLAGS=.*|CFLAGS=\"$flags\"|" \
al@931 1732 -e "s|HOST_SYSTEM=.*|HOST_SYSTEM=$host|" /etc/slitaz/cook.conf
pankso@359 1733 . /etc/slitaz/cook.conf
al@728 1734 sysroot="$CROSS_TREE/sysroot"
al@728 1735 tools="/cross/$arch/tools"
al@728 1736 root="$sysroot"
al@596 1737 # L10n: keep the same width of translations to get a consistent view
al@728 1738 _ 'Target arch : %s' "$ARCH"
al@728 1739 _ 'Configure args : %s' "$CONFIGURE_ARGS"
al@728 1740 _ 'Build flags : %s' "$flags"
al@728 1741 _ 'Arch sysroot : %s' "$sysroot"
al@728 1742 _ 'Tools prefix : %s' "$tools/bin"
paul@455 1743 # Tell the packages manager where to find packages.
al@728 1744 _ 'Packages DB : %s' "$root$DB"
al@728 1745 mkdir -p $root$INSTALLED
al@728 1746 cd $root$DB; rm -f *.bak
al@728 1747 for list in packages.list packages.desc packages.equiv packages.md5; do
al@728 1748 rm -f $list
al@728 1749 ln -s $SLITAZ/packages/$list $list
pankso@426 1750 done
pankso@429 1751 # We must have the cross compiled glibc-base installed or default
pankso@429 1752 # i486 package will be used as dep by tazpkg and then break the
pankso@429 1753 # cross environment
al@728 1754 if [ ! -f "$root$INSTALLED/glibc-base/receipt" ]; then
al@728 1755 colorize 36 $(_ 'WARNING: %s is not installed in sysroot' '(e)glibc-base')
pankso@429 1756 fi
pankso@426 1757 # Show GCC version or warn if not yet compiled.
al@737 1758 if [ -x "$tools/bin/$HOST_SYSTEM-gcc" ]; then
al@728 1759 _ 'Cross compiler : %s' "$HOST_SYSTEM-gcc"
pankso@359 1760 else
al@728 1761 colorize 36 $(_ 'C compiler "%s" is missing' "$HOST_SYSTEM-gcc")
al@728 1762 _ 'Run "%s" to cook a toolchain' 'cross compile'
pankso@397 1763 fi
al@779 1764 footer ;;
al@728 1765
pankso@9 1766 test)
pankso@9 1767 # Test a cook environment.
al@728 1768 _ 'Cook test: testing the cook environment' | log
pankso@9 1769 [ ! -d "$WOK" ] && exit 1
pankso@9 1770 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 1771 cook cooktest ;;
al@728 1772
pankso@1 1773 new)
pankso@1 1774 # Create the package folder and an empty receipt.
pankso@1 1775 pkg="$2"
al@728 1776 [ -z "$pkg" ] && usage
pankso@427 1777 newline
al@899 1778 [ -d "$WOK/$pkg" ] && die 'Package "%s" already exists.' "$pkg"
al@728 1779
al@779 1780 action 'Creating folder "%s"' "$WOK/$pkg"
al@728 1781 mkdir $WOK/$pkg; cd $WOK/$pkg; status
al@728 1782
al@779 1783 action 'Preparing the package receipt...'
pankso@1 1784 cp $DATA/receipt .
al@931 1785 sed -i "s|^PACKAGE=.*|PACKAGE=\"$pkg\"|" receipt
al@728 1786 status; newline
pankso@358 1787
pankso@196 1788 # Interactive mode, asking and seding.
pankso@196 1789 case "$3" in
paul@214 1790 --interactive|-x)
al@728 1791 _ 'Entering interactive mode...'
paul@211 1792 separator
al@728 1793 _ 'Package : %s' "$pkg"
al@728 1794
al@728 1795 _n 'Version : ' ; read answer
al@931 1796 sed -i "s|^VERSION=.*|VERSION=\"$answer\"|" receipt
al@728 1797
al@728 1798 _n 'Category : ' ; read answer
al@931 1799 sed -i "s|^CATEGORY=.*|CATEGORY=\"$answer\"|" receipt
al@728 1800
al@596 1801 # L10n: Short description
al@728 1802 _n 'Short desc : ' ; read answer
al@931 1803 sed -i "s|^SHORT_DESC=.*|SHORT_DESC=\"$answer\"|" receipt
al@728 1804
al@728 1805 _n 'Maintainer : ' ; read answer
al@931 1806 sed -i "s|^MAINTAINER=.*|MAINTAINER=\"$answer\"|" receipt
al@728 1807
al@728 1808 _n 'License : ' ; read answer
al@931 1809 sed -i "s|^LICENSE=.*|LICENSE=\"$answer\"|" receipt
al@728 1810
al@728 1811 _n 'Web site : ' ; read answer
al@931 1812 sed -i "s|^WEB_SITE=.*|WEB_SITE=\"$answer\"|" receipt
pankso@427 1813 newline
al@728 1814
pankso@196 1815 # Wget URL.
al@728 1816 _ 'Wget URL to download source tarball.'
al@728 1817 _n 'Example : ' ; echo '$GNU_MIRROR/$PACKAGE/$TARBALL'
al@728 1818 _n 'Wget url : ' ; read answer
al@931 1819 sed -i "s|^WGET_URL=.*|WGET_URL=\"$answer\"|" receipt
al@728 1820
pankso@196 1821 # Ask for a stuff dir.
al@728 1822 confirm "$(_n 'Do you need a stuff directory? (y/N)')"
al@779 1823 if [ "$?" -eq 0 ]; then
al@779 1824 action 'Creating the stuff directory...'
al@728 1825 mkdir $WOK/$pkg/stuff; status
pankso@196 1826 fi
al@728 1827
pankso@196 1828 # Ask for a description file.
al@728 1829 confirm "$(_n 'Are you going to write a description? (y/N)')"
al@779 1830 if [ "$?" -eq 0 ]; then
al@779 1831 action 'Creating the "%s" file...' 'description.txt'
al@728 1832 touch $WOK/$pkg/description.txt; status
pankso@196 1833 fi
al@728 1834
al@779 1835 footer "$(_ 'Receipt is ready to use.')" ;;
pankso@196 1836 esac ;;
al@728 1837
pankso@1 1838 list)
pankso@1 1839 # Cook a list of packages (better use the Cooker since it will order
pankso@1 1840 # packages before executing cook).
pankso@1 1841 check_root
al@899 1842 [ -z "$2" ] && die 'No list in argument.'
al@899 1843 [ -f "$2" ] || die 'List "%s" not found.' "$2"
al@728 1844
al@728 1845 _ 'Starting cooking the list "%s"' "$2" | log
al@728 1846
al@931 1847 while read pkg; do
pankso@1 1848 cook $pkg || broken
al@931 1849 done < $2
al@931 1850 ;;
al@728 1851
pankso@1 1852 clean-wok)
pankso@1 1853 check_root
al@779 1854 newline; action 'Cleaning all packages files...'
pankso@1 1855 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
al@596 1856 status; newline ;;
al@728 1857
pankso@1 1858 clean-src)
pankso@1 1859 check_root
al@779 1860 newline; action 'Cleaning all packages sources...'
pankso@1 1861 rm -rf $WOK/*/source
al@596 1862 status; newline ;;
al@728 1863
pankso@662 1864 uncook)
pankso@662 1865 cd $WOK
pankso@662 1866 count=0
al@779 1867 title 'Checking for uncooked packages'
al@728 1868
al@951 1869 for i in *; do
pankso@664 1870 unset HOST_ARCH EXTRAVERSION
al@951 1871 [ ! -e $i/receipt ] && continue
al@951 1872 . ./$i/receipt
pankso@662 1873 # Source cooked pkg receipt to get EXTRAVERSION
al@951 1874 if [ -d "$WOK/$i/taz" ]; then
al@951 1875 cd $WOK/$i/taz/$(ls $WOK/$i/taz/ | head -n1)
pascal@950 1876 . ./receipt; cd $WOK
pankso@662 1877 fi
pankso@662 1878 case "$ARCH" in
pankso@662 1879 i486)
al@728 1880 debug "$(_ 'Package "%s"' "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg")"
al@728 1881 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION.tazpkg" ]; then
pankso@662 1882 count=$(($count + 1))
al@951 1883 colorize 34 "$i"
pankso@662 1884 fi ;;
pankso@676 1885 arm*)
paul@665 1886 # Check only packages included in arch
pascal@669 1887 if echo "$HOST_ARCH" | egrep -q "$ARCH|any"; then
pankso@662 1888 # *.tazpkg
al@728 1889 if [ ! -f "$PKGS/$PACKAGE-$VERSION$EXTRAVERSION-$ARCH.tazpkg" ]; then
pankso@662 1890 count=$(($count + 1))
al@951 1891 colorize 34 "$i"
pankso@662 1892 fi
pankso@662 1893 fi ;;
pankso@662 1894 esac
pankso@662 1895 done
al@728 1896
al@899 1897 if [ "$count" -gt 0 ]; then
al@779 1898 footer "$(_p '%s uncooked package' '%s uncooked packages' "$count" "$(colorize 31 "$count")")"
pankso@662 1899 else
al@728 1900 _ 'All packages are cooked :-)'
al@779 1901 newline
pankso@662 1902 fi
al@779 1903 ;;
al@728 1904
pankso@235 1905 pkgdb)
al@857 1906 # Create suitable packages list for TazPkg and only for built packages
al@857 1907 # as well as flavors files for TazLiTo. We don't need logs since we do it
paul@243 1908 # manually to ensure everything is fine before syncing the mirror.
al@987 1909 recreate_split_db
al@857 1910 @@PREFIX@@/libexec/cookutils/pkgdb "$2"
al@742 1911 ;;
al@728 1912
al@932 1913 splitdb)
al@932 1914 # File split.db is useful for searching for split packages.
al@932 1915 recreate_split_db
al@932 1916 ;;
al@932 1917
pankso@1 1918 *)
pankso@1 1919 # Just cook and generate a package.
pankso@1 1920 check_root
pankso@1 1921 time=$(date +%s)
pankso@1 1922 pkg="$1"
pankso@1 1923 [ -z "$pkg" ] && usage
al@899 1924
al@924 1925 # Search last successful cook time in all logs from newer to older
al@924 1926 for i in '' $(seq 0 9 | sed 's|^|.|'); do
al@924 1927 [ -f "$LOGS/$pkg.log$i" ] || break
al@924 1928 lastcooktime=$(sed '/^Cook time/!d; s|.*: *\([0-9]*\)s.*|\1|' \
al@924 1929 $LOGS/$pkg.log$i 2>/dev/null | sed '$!d')
al@924 1930 [ -n "$lastcooktime" ] && break
al@924 1931 done
al@924 1932
pankso@44 1933 receipt="$WOK/$pkg/receipt"
al@728 1934 check_pkg_in_wok
al@728 1935 newline
pankso@47 1936
pankso@377 1937 unset inst
pankso@377 1938 unset_receipt
pankso@377 1939 . $receipt
al@728 1940
pankso@377 1941 # Handle cross compilation.
pankso@377 1942 case "$ARCH" in
pankso@676 1943 arm*)
al@728 1944 if [ -z "$HOST_ARCH" ]; then
al@728 1945 _ 'cook: HOST_ARCH is not set in "%s" receipt' "$pkg"
al@728 1946 error="$(_ 'package "%s" is not included in %s' "$pkg" "$ARCH")"
al@728 1947 _ 'cook: %s' "$error"
al@728 1948 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
al@728 1949 _ 'Cook skip: %s' "$error" | log
al@728 1950 newline
al@899 1951 broken; exit 1
pankso@377 1952 fi ;;
pankso@377 1953 esac
pankso@377 1954
paul@387 1955 # Some packages are not included in some arch or fail to cross compile.
pankso@398 1956 : ${HOST_ARCH=i486}
al@728 1957 debug "$(_ 'Host arch %s' "$HOST_ARCH")"
pankso@675 1958 # Handle arm{v6hf,v7,..}
pankso@675 1959 if ! $(echo "$HOST_ARCH" | egrep -q "${ARCH%v[0-9]*}|any"); then
al@728 1960 _ 'cook: %s' "HOST_ARCH=$HOST_ARCH"
al@728 1961 error="$(_ "package \"%s\" doesn't cook or is not included in %s" "$pkg" "$ARCH")"
al@728 1962 _ 'cook: %s' "error"
al@728 1963 [ -n "$CROSS_BUGS" ] && _ 'bugs: %s' "$CROSS_BUGS"
al@728 1964 _ 'Cook skip: %s' "$error" | log
al@931 1965 sed -i "/^${pkg}$/d" $broken
al@728 1966 newline
al@728 1967 exit 0
pankso@377 1968 fi
pankso@377 1969
pankso@47 1970 # Skip blocked, 3 lines also for the Cooker.
al@899 1971 grep -q "^$pkg$" $blocked && [ "$2" != '--unblock' ] &&
al@899 1972 die 'Package "%s" is blocked' "$pkg"
pankso@47 1973
pascal@289 1974 try_aufs_chroot "$@"
pascal@289 1975
pankso@47 1976 # Log and source receipt.
al@899 1977 _ 'Cook started for: %s' "<a href='cooker.cgi?pkg=${pkg//+/%2B}'>$pkg</a>" | log
pankso@16 1978 echo "cook:$pkg" > $command
al@899 1979
al@899 1980 [ -n "$lastcooktime" ] && echo "cook:$pkg $lastcooktime $(date +%s)" >> $cooktime
al@899 1981
pascal@824 1982 while read cmd duration start; do
pascal@824 1983 [ $(($start + $duration)) -lt $(date +%s) ] &&
pascal@824 1984 echo "sed -i '/^$cmd $duration/d' $cooktime"
pascal@824 1985 done < $cooktime | sh
pascal@285 1986
pascal@285 1987 # Display and log info if cook process stopped.
paul@647 1988 # FIXME: gettext not working (in single quotes) here!
al@596 1989 trap '_ "\n\nCook stopped: control-C\n\n" | \
pascal@285 1990 tee -a $LOGS/$pkg.log' INT
pascal@285 1991
al@932 1992 update_split_db
al@932 1993
pankso@1 1994 # Handle --options
pankso@1 1995 case "$2" in
pankso@1 1996 --install|-i)
pankso@1 1997 inst='yes' ;;
al@728 1998
slaxemulator@501 1999 --pack)
al@924 2000 [ -d "$WOK/$pkg/install" ] || die 'Need to build "%s"' "$pkg"
al@924 2001 [ ! -d "$WOK/$pkg/taz" ] || rm -rf "$WOK/$pkg/taz"
al@924 2002 [ ! -f "$LOGS/$pkg-pack.log" ] || rm -rf $LOGS/$pkg-pack.log
al@926 2003 sed -i '$ s|$| (packing)|' $activity
al@912 2004 packall 2>&1 | tee -a $LOGS/$pkg-pack.log
al@924 2005 clean_log "$pkg-pack"
al@924 2006 time=$(($(date +%s) - $time))
al@924 2007 summary | sed 's|^Cook |Pack |' | tee -a $LOGS/$pkg-pack.log
al@992 2008 put_status $pkg Done
al@899 2009 rm -f $command
slaxemulator@501 2010 exit 0 ;;
al@989 2011
al@989 2012 --trials|-t)
al@989 2013 trials='yes' ;;
pankso@1 2014 esac
pankso@1 2015
pascal@793 2016 # Rotate log
pascal@793 2017 for i in $(seq 9 -1 1); do
pascal@793 2018 j=$(($i - 1))
al@837 2019 [ -e $LOGS/$pkg.log.$j ] && mv -f $LOGS/$pkg.log.$j $LOGS/$pkg.log.$i
pascal@793 2020 done
al@837 2021 [ -e $LOGS/$pkg.log ] && mv $LOGS/$pkg.log $LOGS/$pkg.log.0
al@837 2022
paul@62 2023 # Check if wanted is built now so we have separate log files.
pankso@295 2024 for wanted in $WANTED ; do
pascal@291 2025 if grep -q "^$wanted$" $blocked; then
al@899 2026 broken
al@728 2027 rm -f $command
al@899 2028 die 'WANTED package "%s" is blocked' "$wanted"
pankso@217 2029 fi
pascal@291 2030 if grep -q "^$wanted$" $broken; then
al@899 2031 broken
al@728 2032 rm -f $command
al@899 2033 die 'WANTED package "%s" is broken' "$wanted"
pankso@218 2034 fi
pascal@291 2035 if [ ! -d "$WOK/$wanted/install" ]; then
al@899 2036 cook "$wanted" || { broken; exit 1; }
pankso@137 2037 fi
pascal@291 2038 done
pankso@1 2039
pankso@1 2040 # Cook and pack or exit on error and log everything.
al@1010 2041 ((((cookit $@ 2>&1; echo $? >&3) | loglimit 50 > $LOGS/$pkg.log) 3>&1) | (read rq; exit $rq))
al@1010 2042 rq=$? # the return code of `cookit $@` above command
al@1010 2043
al@1010 2044 # Remove build dependencies both when `cookit` done or fail
pankso@15 2045 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 2046 cookit_quality
al@1010 2047
al@1010 2048 # Log and stop if `cookit` fails
al@1010 2049 if [ $rq -eq 1 ]; then
al@1010 2050 debug_info | tee -a $LOGS/$pkg.log
al@1010 2051 put_status $pkg Failed
al@1010 2052 rm -f $command
al@1010 2053 broken; exit 1
al@1010 2054 fi
al@1010 2055
al@1010 2056 # Proceed only if `cookit` return code is zero-OK
al@904 2057 packall 2>&1 | loglimit 5 >> $LOGS/$pkg.log
al@1010 2058
pankso@1 2059 clean_log
pankso@33 2060
pankso@33 2061 # Exit if any error in packing.
al@962 2062 if [ "${COOKOPTS/skip-log-errors/}" == "$COOKOPTS" ] &&
al@962 2063 grep -Ev "(/root/.cvspass|conftest|df: /|rm: can't remove)" $LOGS/$pkg.log | \
al@962 2064 grep -Eq "(^ERROR|: No such file or directory|not remade because of errors|ake: \*\*\* .* Error)"; then
pankso@33 2065 debug_info | tee -a $LOGS/$pkg.log
al@992 2066 put_status $pkg Failed
al@728 2067 rm -f $command
al@899 2068 broken; exit 1
pankso@33 2069 fi
pankso@358 2070
pankso@310 2071 # Create an XML feed
pankso@310 2072 gen_rss
pankso@358 2073
pankso@1 2074 # Time and summary
pankso@1 2075 time=$(($(date +%s) - $time))
pankso@1 2076 summary | tee -a $LOGS/$pkg.log
pankso@427 2077 newline
pankso@1 2078
al@899 2079 # We may want to install/update (outside aufs jail!).
al@899 2080 [ -s /aufs-umount.sh ] || install_package
al@899 2081
al@992 2082 put_status $pkg Done
pankso@358 2083
al@850 2084 # Finally we DON'T WANT to build the *-dev or packages with WANTED="$pkg"
al@899 2085 # If you want automation, use the Cooker Build Bot.
al@899 2086 rm -f $command
al@899 2087 ;;
pankso@1 2088 esac
pankso@1 2089
pankso@1 2090 exit 0